Package: simplifyEnrichment
Type: Package
Title: Simplify Functional Enrichment Results
Version: 2.6.0
Date: 2026-01-30
Authors@R: person("Zuguang", "Gu", email = "guzuguang@suat-sz.edu.cn", role = c("aut", "cre"),
                  comment = c('ORCID'="0000-0002-7395-8709"))
Depends: R (>= 4.1.0)
Imports: simona, ComplexHeatmap (>= 2.7.4), grid, circlize, GetoptLong,
        digest, tm, GO.db, AnnotationDbi, slam, methods, clue,
        grDevices, stats, utils, cluster (>= 1.14.2), colorspace,
        GlobalOptions (>= 0.1.0)
Suggests: knitr, ggplot2, cowplot, mclust, apcluster, MCL, dbscan,
        igraph, gridExtra, dynamicTreeCut, testthat, gridGraphics,
        flexclust, BiocManager, InteractiveComplexHeatmap (>= 0.99.11),
        shiny, shinydashboard, cola, hu6800.db, rmarkdown, genefilter,
        gridtext, fpc
Description: A new clustering algorithm, "binary cut", for clustering similarity matrices of functional terms
         is implemeted in this package. It also provides functions for visualizing, summarizing and comparing the clusterings.
biocViews: Software, Visualization, GO, Clustering, GeneSetEnrichment
URL: https://github.com/jokergoo/simplifyEnrichment,
        https://simplifyEnrichment.github.io
VignetteBuilder: knitr
License: MIT + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.1
git_url: https://git.bioconductor.org/packages/simplifyEnrichment
git_branch: RELEASE_3_23
git_last_commit: 9a476a3
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:43:54 UTC; biocbuild
Author: Zuguang Gu [aut, cre] (ORCID: <https://orcid.org/0000-0002-7395-8709>)
Maintainer: Zuguang Gu <guzuguang@suat-sz.edu.cn>

#' Cluster terms based on their similarity matrix
#'
#' @param mat A similarity matrix.
#' @param method The clustering methods. Value should be in [`all_clustering_methods()`].
#' @param control A list of parameters passed to the corresponding clustering function.
#' @param verbose Whether to print messages.
#'
#' @details
#' New clustering methods can be registered by [`register_clustering_methods()`].
#'
#' Please note it is better to directly use `cluster_terms()` for clustering while not the individual ``cluster_by_*`` functions
#' because `cluster_terms()` does additional cluster label adjustment.
#' 
#' By default, there are the following clustering methods and corresponding clustering functions:
#' 
#' - `kmeans` see [`cluster_by_kmeans()`].
#' - `dynamicTreeCut` see [`cluster_by_dynamicTreeCut()`].
#' - `mclust` see [`cluster_by_mclust()`].
#' - `apcluster` see [`cluster_by_apcluster()`].
#' - `hdbscan` see [`cluster_by_hdbscan()`].
#' - `fast_greedy` see [`cluster_by_fast_greedy()`].
#' - `louvain` see [`cluster_by_louvain()`].
#' - `walktrap` see [`cluster_by_walktrap()`].
#' - `MCL` see [`cluster_by_MCL()`].
#' - `binary_cut` see [`binary_cut()`].
#' 
#' The additional argument in individual clustering functions can be set with the `control` argument
#' in `cluster_terms()`.
#'
#' @returns
#' A vector of numeric cluster labels.
#' @export
#' @rdname cluster_terms
cluster_terms = function(mat, method = "binary_cut", control = list(), verbose = se_opt$verbose) {
	
	if(nrow(mat) != ncol(mat)) {
		stop_wrap("The matrix should be square.")
	}

	if(verbose) message(qq("Cluster @{nrow(mat)} terms by '@{method}'..."), appendLF = FALSE)
	flush.console()

	fun = get_clustering_method(method, control = control)
	
	t1 = Sys.time()
	cl = fun(mat)
	t2 = Sys.time()

	t_diff = t2 - t1
	t_diff = format(t_diff)
	if(verbose) message(qq(" @{length(unique(cl))} clusters, used @{t_diff}."))

	if(length(unique(cl)) > 1) {
		if(method != "binary_cut") {
			#reorder the class labels
			class_mean = tapply(1:nrow(mat), cl, function(ind) {
				colMeans(mat[ind, , drop = FALSE])
			})
			class_mean = do.call(rbind, class_mean)
			ns = nrow(class_mean)

			class_dend = as.dendrogram(hclust(stats::dist(class_mean)))
			class_dend = reorder(class_dend, wts = rowSums(class_mean))
			map = structure(1:ns, names = order.dendrogram(class_dend))

			cl = map[as.character(cl)]
		}
	}

	attr(cl, "running_time") = t_diff

	return(cl)
}


#' @param max_k Maximal _k_ for k-means/PAM clustering. K-means/PAM clustering is applied from k = 2 to k = max_k.
#' @param ... Other arguments.
#'
#' @details
#' `cluster_by_kmeans()`: The best k for k-means clustering is determined according to the "elbow" or "knee" method on
#' the distribution of within-cluster sum of squares (WSS) on each k. All other arguments are passed
#' from `...` to [`stats::kmeans()`].
#'
#' @export
#' @rdname cluster_terms
cluster_by_kmeans = function(mat, max_k = max(2, min(round(nrow(mat)/5), 100)), ...) {
	
	cl = list()
	wss = NULL

	if(max_k <= 2) {
		stop_wrap("`max_k` should be larger than 2.")
	}

	for (i in 2:max_k) {
		suppressWarnings(km <- kmeans(mat, centers = i, iter.max = 50))
		cl[[i - 1]] = km$cluster
		wss[i - 1] = sum(km$withinss)
	}
	best_km = min(elbow_finder(2:max_k, wss)[1], knee_finder(2:max_k, wss)[1])

	cl[[best_km - 1]]
}


#' @details
#' `cluster_by_pam()`: PAM is applied by [`fpc::pamk()`] which can automatically select the best k.
#' All other arguments are passed from `...` to [`fpc::pamk()`].
#'
#' @export
#' @rdname cluster_terms
cluster_by_pam = function(mat, max_k = max(2, min(round(nrow(mat)/10), 100)), ...) {

	check_pkg("fpc", bioc = FALSE)

	best = fpc::pamk(mat, krange = 2:max_k, ...)
	best$pamobject$clustering
}

# https://stackoverflow.com/questions/2018178/finding-the-best-trade-off-point-on-a-curve
elbow_finder = function(x_values, y_values) {
	# Max values to create line
	max_x_x = max(x_values)
	max_x_y = y_values[which.max(x_values)]
	max_y_y = max(y_values)
	max_y_x = x_values[which.max(y_values)]
	max_df = data.frame(x = c(max_y_x, max_x_x), y = c(max_y_y, max_x_y))

	# Creating straight line between the max values
	fit = lm(max_df$y ~ max_df$x)

	# Distance from point to line
	distances = c()
	for(i in seq_along(x_values)) {
		distances = c(distances, abs(coef(fit)[2]*x_values[i] - y_values[i] + coef(fit)[1]) / sqrt(coef(fit)[2]^2 + 1^2))
	}

	# Max distance point
	x_max_dist = x_values[which.max(distances)]
	y_max_dist = y_values[which.max(distances)]

	return(c(x_max_dist, y_max_dist))
}

# https://raghavan.usc.edu//papers/kneedle-simplex11.pdf
knee_finder = function(x, y) {
	n = length(x)
	a = (y[n] - y[1])/(x[n] - x[1])
	b = y[1] - a*x[1]
	d = a*x - y
	x[which.max(d)]
}

#' @param minClusterSize Minimal number of objects in a cluster. Pass to [`dynamicTreeCut::cutreeDynamic()`].
#' 
#' @details
#' `cluster_by_dynamicTreeCut()`: All other arguments are passed from `...` to [`dynamicTreeCut::cutreeDynamic()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_dynamicTreeCut = function(mat, minClusterSize = 5, ...) {

	check_pkg("dynamicTreeCut", bioc = FALSE)

	cl = dynamicTreeCut::cutreeDynamic(hclust(stats::dist(mat)), distM = 1 - mat, minClusterSize = minClusterSize, verbose = 0, ...)
	unname(cl)
}


#' @details
#' `cluster_by_fast_greedy()`: All other arguments are passed from `...` to [`igraph::cluster_fast_greedy()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_fast_greedy = function(mat, ...) {
	check_pkg("igraph", bioc = FALSE)

	g = igraph::graph_from_adjacency_matrix(mat, mode = "upper", weighted = TRUE)
	imc = igraph::cluster_fast_greedy(g, ...)
	as.vector(igraph::membership(imc))
}

#' @details
#' `cluster_by_leading_eigen()`: All other arguments are passed from `...` to [`igraph::cluster_leading_eigen()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_leading_eigen = function(mat, ...) {
	check_pkg("igraph", bioc = FALSE)

	g = igraph::graph_from_adjacency_matrix(mat, mode = "upper", weighted = TRUE)
	imc = igraph::cluster_leading_eigen(g, ...)
	as.vector(igraph::membership(imc))
}

#' @details
#' `cluster_by_louvain()`: All other arguments are passed from `...` to [`igraph::cluster_louvain()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_louvain = function(mat, ...) {
	check_pkg("igraph", bioc = FALSE)

	g = igraph::graph_from_adjacency_matrix(mat, mode = "upper", weighted = TRUE)
	imc = igraph::cluster_louvain(g, ...)
	as.vector(igraph::membership(imc))
}

#' @details
#' `cluster_by_walktrap()`: All other arguments are passed from `...` to [`igraph::cluster_walktrap()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_walktrap = function(mat, ...) {
	check_pkg("igraph", bioc = FALSE)

	g = igraph::graph_from_adjacency_matrix(mat, mode = "upper", weighted = TRUE)
	imc = igraph::cluster_walktrap(g, ...)
	as.vector(igraph::membership(imc))
}

#' @param G Passed to the `G` argument in [`mclust::Mclust()`] which is the number of clusters.
#' @details
#' `cluster_by_mclust()`: All other arguments are passed from `...` to [`mclust::Mclust()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_mclust = function(mat, G = seq_len(max(2, min(round(nrow(mat)/5), 100))), ...) {
	
	check_pkg("mclust", bioc = FALSE)

	mclustBIC = mclust::mclustBIC

	fit = mclust::Mclust(mat, G = G, verbose = FALSE, control = mclust::emControl(itmax = c(1000, 1000)), ...)

	unname(fit$classification)
}

#' @param s Passed to the `s` argument in [`apcluster::apcluster()`].
#' @details
#' `cluster_by_apcluster()`: All other arguments are passed from `...` to [`apcluster::apcluster()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_apcluster = function(mat, s = apcluster::negDistMat(r = 2), ...) {
	
	check_pkg("apcluster", bioc = FALSE)

	x = apcluster::apcluster(s, mat, ...)
	cl = numeric(nrow(mat))
	for(i in seq_along(x@clusters)) {
		cl[x@clusters[[i]]] = i
	}
	cl
}


#' @param minPts Passed to the `minPts` argument in [`dbscan::hdbscan()`].
#' @details
#' `cluster_by_hdbscan()`: All other arguments are passed from `...` to [`dbscan::hdbscan()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_hdbscan = function(mat, minPts = 5, ...) {
	
	check_pkg("dbscan", bioc = FALSE)

	dbscan::hdbscan(mat, minPts = minPts, ...)$cluster
}

#' @param addLoops Passed to the `addLoops` argument in [`MCL::mcl()`].
#' @details
#' `cluster_by_MCL()`: All other arguments are passed from `...` to [`MCL::mcl()`].
#' 
#' @export
#' @rdname cluster_terms
cluster_by_MCL = function(mat, addLoops = TRUE, ...) {
	
	check_pkg("MCL", bioc = FALSE)

	MCL::mcl(mat, addLoops = addLoops, allow1 = TRUE, ...)$Cluster
}

GO_EXCLUDE_WORDS = c("via", "protein", "factor", "side", "type", "specific", "regulation", "process")


# -term a vector of texts

#' @import tm
make_term_document_matrix = function(term,
	exclude_words = NULL, stop_words = stopwords(),
	min_word_length = 2, tokenizer = 'words', transform_case = tolower,
	remove_numbers = TRUE, remove_punctuation = TRUE, custom_transformer = NULL,
	stemming = FALSE, dictionary = NULL) {
	
	suppressWarnings({
		docs = VCorpus(VectorSource(term))
		# Convert the text to lower case
		docs = tm_map(docs, content_transformer(transform_case))
		if (remove_numbers) {
			# Remove numbers
			docs = tm_map(docs, removeNumbers)
		}
		# Remove stopwords for the language
		docs = tm_map(docs, removeWords, stop_words)
		if (remove_punctuation) {
			# Remove punctuations
			docs = tm_map(docs, removePunctuation)
		}
		# Eliminate extra white spaces
		docs = tm_map(docs, stripWhitespace)
		# Remove your own stopwords
		docs = tm_map(docs, removeWords, exclude_words)
		# Apply any user-provided transformer
		if (!is.null(custom_transformer)) {
			docs = tm_map(docs, content_transformer(custom_transformer))
		}

		# Create term-document matrix
		tdm = TermDocumentMatrix(
			docs,
			control = list(
				wordLengths = c(min_word_length, Inf),
				tokenize = tokenizer,
				stemming = stemming,
				dictionary = dictionary,
				tolower = FALSE
			)
		)
	})

	tdm
}

prepare_keywords_tdm_for_GO = function(use_desc = FALSE, ...) {

	all_go = as.list(GO.db::GOTERM)

	ontology = sapply(all_go, slot, "Ontology")
	term = sapply(all_go, slot, "Term")
	l = ontology %in% c("BP", "CC", "MF")
	term = term[l]
	term_id = names(term)

	if(use_desc) {
		suppressMessages(term <- select(GO.db::GO.db, keys = term_id, columns = "DEFINITION")$DEFINITION)
		tdm = make_term_document_matrix(term, stop_words = c(stopwords(), GO_EXCLUDE_WORDS), ...)
	} else {
		tdm = make_term_document_matrix(term, stop_words = c(stopwords(), GO_EXCLUDE_WORDS), ...)
	}

	colnames(tdm) = term_id
	attr(tdm, "GO_dbInfo") = GO.db::GO_dbInfo()
	
	tdm
}

keyword_enrichment = function(term_id, tdm, min_bg = 5, min_term = 2) {
	tdm2 = tdm[row_sums(tdm) >= min_bg, ]

	l = colnames(tdm2) %in% term_id

	n = nrow(tdm2)
	n_term = numeric(n)
	n_bg = numeric(n)
	p = numeric(n)
	for(i in seq_len(n)) {
		if(interactive() && se_opt$verbose) {
			if(i %% 100 == 0 || i == n) {
				message(strrep("\r", 100), appendLF = FALSE)
				message(qq("keyword enrichment, @{i}/@{n}..."), appendLF = FALSE)
			}
		}
		v = as.vector(tdm2[i, ])
		s11 = sum(v & l)
		if(s11 < min_term) {
			next
		}
		s12 = sum(!v & l)
		s21 = sum(v & !l)
		s22 = sum(!v & !l)

		n_term[i] = s11
		n_bg[i] = s11 + s21

		p[i] = fisher.test(cbind(c(s11, s21), c(s12, s22)), alternative = "greater")$p.value

	}
	if(interactive() && se_opt$verbose) {
		message("")
	}

	df = data.frame(keyword = rownames(tdm2), n_term = n_term, n_bg = n_bg, p = p)
	df = df[df$n_term >= min_term, , drop = FALSE]
	df$padj = p.adjust(df$p)
	df[order(df$padj, df$p), , drop = FALSE]
}


#' Keyword enrichment for GO terms
#'
#' @param go_id A vector of GO IDs.
#' @param min_bg Minimal number of GO terms (in the background, i.e. all GO temrs in the GO database) that contain a specific keyword.
#' @param min_term Minimal number of GO terms (GO terms in ``go_id``) that contain a specific keyword.
#'
#' @details
#' The enrichment is applied by Fisher's exact test. For a keyword, there is the following 2x2 contigency table:
#'
#' ```
#'                       | contains the keyword | does not contain the keyword
#'     In the GO set     |          s11         |          s12
#'     Not in the GO set |          s21         |          s22
#' ```
#' 
#' where `s11`, `s12`, `s21` and `s22` are the counts of GO terms in the four categories.
#'
#' @return
#' A data frame with keyword enrichment results.
#' @export
#' @examples
#' \donttest{
#' go_id = random_GO(100)
#' keyword_enrichment_from_GO(go_id)
#' }
keyword_enrichment_from_GO = function(go_id, min_bg = 5, min_term = 2) {

	if(is.null(env$tdm_GO)) {
		# env$tdm_GO = readRDS("~/project/development/simplifyEnrichment/inst/extdata/tdm_GO.rds")
		env$tdm_GO = readRDS(system.file("extdata", "tdm_GO.rds", package = "simplifyEnrichment"))
	}

	df = keyword_enrichment(go_id, env$tdm_GO, min_bg, min_term)
	rownames(df) = NULL
	df
}

.onAttach = function(libname, pkgname) {
    version = packageDescription(pkgname, fields = "Version")

  	msg = paste0("========================================
", pkgname, " version ", version, "
Bioconductor page: https://bioconductor.org/packages/simplifyEnrichment/
Github page: https://github.com/jokergoo/simplifyEnrichment
Documentation: https://jokergoo.github.io/simplifyEnrichment/
Examples: https://simplifyenrichment.github.io/

If you use it in published research, please cite:
Gu, Z. simplifyEnrichment: an R/Bioconductor package for Clustering and 
  Visualizing Functional Enrichment Results, Genomics, Proteomics & 
  Bioinformatics 2022.

This message can be suppressed by:
  suppressPackageStartupMessages(library(simplifyEnrichment))
========================================
")	

    packageStartupMessage(msg)

    ComplexHeatmap::ht_opt(save_last = TRUE)
}


GO_global_word_freq = readRDS(system.file("extdata", "GO_global_word_freq.rds", package = "simplifyEnrichment"))

env = new.env()

#' Calculate Gene Ontology (GO) semantic similarity matrix
#'
#' @param go_id A vector of GO IDs.
#' @param ont Sub-ontology of GO. Value should be one of "BP", "CC" or "MF". If it is not specified,
#'      the function automatically identifies it by random sampling 10 IDs from `go_id` (see `guess_ont()`).
#' @param db Annotation database. It should be an OrgDb package name from \url{https://bioconductor.org/packages/release/BiocViews.html#___OrgDb}. The value
#'    can also directly be an `OrgDb` object.
#' @param measure Semantic measure for the GO similarity, pass to [`simona::term_sim()`]. All valid values are in [`simona::all_term_sim_methods()`].
#'
#' @details
#' The default similarity method is "Sim_XGraSM_2013". Since the semantic similarities are calculated based on gene annotations to GO terms,
#' I suggest users also try the following methods:
#' 
#' - `"Sim_Lin_1998"`
#' - `"Sim_Resnik_1999"`
#' - `"Sim_Relevance_2006"`
#' - `"Sim_SimIC_2010"`
#' - `"Sim_XGraSM_2013"`
#' - `"Sim_EISI_2015"`
#' - `"Sim_AIC_2014"`
#' - `"Sim_Wang_2007"`
#' - `"Sim_GOGO_2018"`
#'
#' @return
#' `GO_similarity()` returns a symmetric matrix.
#' @export
#' @import simona
#' @import GetoptLong
#' @examples
#' \donttest{
#' go_id = random_GO(100)
#' mat = GO_similarity(go_id)
#' }
GO_similarity = function(go_id, ont = NULL, db = "org.Hs.eg.db", measure = "Sim_XGraSM_2013") {

	if(is.null(ont)) {
		ont = guess_ont(go_id, db)
		if(is.null(ont)) {
			stop_wrap("Cannot determine which GO ontology (BP/CC/MF) you are using. Please manualy set `ont` argument.")
		}
		message(qq("You haven't provided value for `ont`, guess it as `@{ont}`."))
	}

	hash = digest(list(ont = ont, db = db))
	if(is.null(env$go[[hash]])) {
		dag = create_ontology_DAG_from_GO_db(namespace = ont, org_db = db, relations = c("part_of", "regulates"))

		ic = term_IC(dag, method = "IC_annotation")
		all_go_id = names(ic[!is.na(ic)])

		env$go[[hash]] = list(dag = dag, all_go_id = all_go_id)
	} else {
		dag = env$go[[hash]]$dag
		all_go_id = env$go[[hash]]$all_go_id
	}
    
    go_removed = setdiff(go_id, all_go_id)
	if(length(go_removed)) {
		message(qq("@{length(go_removed)}/@{length(go_id)} GO term@{ifelse(length(go_removed) == 1, ' is', 's are')} removed."))
	}

	go_id = intersect(go_id, all_go_id)
	go_sim = term_sim(dag, go_id, method = measure)

	attr(go_sim, "measure") = measure
	attr(go_sim, "ontology") = paste0("GO:", ont)
	return(go_sim)
}


split_by_block = function(n, size) {
	size = min(c(n, size))
	REST = n %% size
    LARGE = n - REST
    NBLOCKS = n %/% size
    GROUP = rep(1:NBLOCKS, each = size)
    if (REST > 0) GROUP = c(GROUP, rep(NBLOCKS + 1, REST))
    split(1:n, GROUP)
}


#' @rdname GO_similarity
#'
#' @details
#' In `guess_ont()`, only 10 random GO IDs are checked.
#'
#' @return
#' `guess_ont()` returns a single character scalar of "BP", "CC" or "MF". 
#' If there are more than one ontologies detected. It returns `NULL`.
#' 
#' @export
#' @import AnnotationDbi
#' @examples
#' \donttest{
#' go_id = random_GO(100)
#' guess_ont(go_id)
#' }
guess_ont = function(go_id, db = 'org.Hs.eg.db') {

	if(is.character(db)) {
		db = get(db, asNamespace(db))
	}
	test_go_id = sample(go_id, min(c(length(go_id), 10)))
	suppressMessages(df <- select(db, keys = test_go_id, columns = "ONTOLOGY", keytype = "GO"))
	guess_ont = unique(df$ONTOLOGY)
	guess_ont = guess_ont[!is.na(guess_ont)]
	if(length(guess_ont) != 1) {
		return(NULL)
	} else {
		return(guess_ont)
	}
}

#' @rdname GO_similarity
#'
#' @param n Number of GO IDs.
#' 
#' @details
#' In `random_GO()`, only GO terms with gene annotations are sampled.
#'
#' @return
#' `random_GO()` returns a vector of GO IDs.
#' @export
random_GO = function(n, ont = c("BP", "CC", "MF"), db = "org.Hs.eg.db") {
	ont = match.arg(ont)
	hash = digest(list(ont = ont, db = db))
	if(is.null(env$go[[hash]])) {
		dag = create_ontology_DAG_from_GO_db(namespace = ont, org_db = db, relations = c("part_of", "regulates"))

		ic = term_IC(dag, method = "IC_annotation")
		all_go_id = names(ic[!is.na(ic)])

		env$go[[hash]] = list(dag = dag, all_go_id = all_go_id)
	} else {
		dag = env$go[[hash]]$dag
		all_go_id = env$go[[hash]]$all_go_id
	}

	sample(all_go_id, min(n, length(all_go_id)))
}

context("test GO_similarity")

# go_id = random_GO(100)
# m1 = GO_similarity(go_id)
# m2 = GO_similarity(go_id, mc.cores = 2)
# if(identical(topenv(), .GlobalEnv) {
# 	semData = env$semData	
# } else {
# 	semData = simplifyEnrichment:::env$semData
# }
# m3 = termSim(go_id, go_id, method = "Rel", semData = semData)

# test_that("test dend_noGO_similarityde_apply()", {
# 	expect_that(m1, identical(m3))
# 	expect_that(m2, identical(m3))
# })

#' Compare clustering methods
#'
#' @rdname compare
#' @param mat The similarity matrix.
#' @param method Which methods to compare. All available methods are in [`all_clustering_methods()`].
#'         A value of `"all"` takes all available methods. By default "mclust" is excluded because its long runtime.
#' @param verbose Whether to print messages.
#'
#' Ddetails
#' The function compares following default clustering methods by default:
#'
#' -``kmeans`` see `cluster_by_kmeans`.
#' -``pam`` see `cluster_by_pam`.
#' -``dynamicTreeCut`` see `cluster_by_dynamicTreeCut`.
#' -``mclust`` see `cluster_by_mclust`. By default it is not included.
#' -``apcluster`` see `cluster_by_apcluster`.
#' -``hdbscan`` see `cluster_by_hdbscan`.
#' -``fast_greedy`` see `cluster_by_fast_greedy`.
#' -``louvain`` see `cluster_by_louvain`.
#' -``walktrap`` see `cluster_by_walktrap`.
#' -``MCL`` see `cluster_by_MCL`.
#' -``binary_cut`` see `binary_cut`.
#'
#' Also the user-defined methods in `all_clustering_methods` are also compared.
#'
#' @return
#' `cmp_make_clusters()` returns a list of cluster label vectors from different clustering methods.
#' @export
cmp_make_clusters = function(mat, method = setdiff(all_clustering_methods(), "mclust"),
	verbose = TRUE) {

	clt = list()
	if("all" %in% method) {
		method = all_clustering_methods()
	}

	clt = lapply(method, function(me) {
		oe = try(cl <- cluster_terms(mat, me, verbose = verbose))
		if(inherits(oe, "try-error")) {
			rep(NA, nrow(mat))
		} else {
			cl
		}
	})
	names(clt) = method
	clt = as.data.frame(clt)

	clt
}

#' @rdname compare
#' @param clt A list of clusterings from `cmp_make_clusters()`.
#' @param plot_type What type of plots to make. See **Details**.
#' @param nrow Number of rows of the layout when ``plot_type`` is set to `"heatmap"`.
#'
#' @details
#' For `cmp_make_plot()`, if `plot_type` is the default value `"mixed"`, a figure with three panels will be generated:
#'
#' - A heatmap of the similarity matrix with different classifications as row annotations.
#' - A heatmap of the pair-wise concordance of the classifications of every two clustering methods.
#' - Barplots of the difference scores for each method (calculated by `difference_score`), the number
#'    of clusters (total clusters and the clusters with size >= 5) and the mean similarity of the terms 
#'    that are in the same clusters.
#'
#' If `plot_type` is `"heatmap"`. There are heatmaps for the similarity matrix under clusterings
#' from different methods. The last panel is a table with the number of clusters under different
#' clusterings.
#'
#' @return
#' `cmp_make_plot()` returns no value.
#' @export
cmp_make_plot = function(mat, clt, plot_type = c("mixed", "heatmap"), nrow = 3) {

	clt = as.data.frame(clt)
	methods = names(clt)
	
	plot_type = match.arg(plot_type)[1]

	check_pkg("cowplot", bioc = FALSE)
		
	if(plot_type == "mixed") {

		l = sapply(clt, function(x) any(is.na(x)))
		clt2 = clt[!l]
		methods = methods[!l]
		
		if("binary_cut" %in% names(clt)) {
			ref_class = clt2[, "binary_cut"]
		} else {
			ref_class = clt2[, which.min(vapply(clt2, function(x) length(unique(x)), 0))]
		}
		clt2 = lapply(clt2, function(x) as.character(relabel_class(x, ref_class, return_map = FALSE)))
		clt2 = as.data.frame(clt2)

		ht1 = Heatmap(mat, col = colorRamp2(c(0, quantile(mat, 0.975)), c("white", "red")),
			name = "Similarity",
			show_row_names = FALSE, show_column_names = FALSE, 
			# cluster_rows = dend, cluster_columns = dend,
			show_row_dend = FALSE, show_column_dend = FALSE) +
			Heatmap(as.matrix(clt2), show_heatmap_legend = FALSE, 
				width = unit(5, "mm")*ncol(clt2), column_names_rot = 45)
		p0 = grid.grabExpr(draw(ht1))

		stats = cmp_calc_stats(mat, clt2)
		stats$method = factor(rownames(stats), levels = rownames(stats))

		check_pkg("ggplot2", bioc = FALSE)

		suppressWarnings(
			p1 <- ggplot2::ggplot(stats, ggplot2::aes(x = stats$method, y = stats$diff_s)) +
			ggplot2::geom_bar(stat = "identity") + ggplot2::ylab("Difference score") +
			ggplot2::theme(axis.title.x = ggplot2::element_blank(), axis.text.x = ggplot2::element_blank())
		)

		df1 = stats[, c("method", "n_all")]; colnames(df1) = c("method", "value")
		df2 = stats[, c("method", "n_large")]; colnames(df2) = c("method", "value")
		df1$type = "All sizes"
		df2$type = "Size \u2265 5"
		df = rbind(df1, df2)
		suppressWarnings(
			p2 <- ggplot2::ggplot(df, ggplot2::aes(x = df$method, y = df$value, col = df$type, fill = df$type)) +
			ggplot2::geom_bar(stat = "identity", position = ggplot2::position_dodge()) + ggplot2::ylab("Number of clusters") + ggplot2::labs(col = "Type", fill = "Type") +
			ggplot2::theme(axis.title.x = ggplot2::element_blank(), axis.text.x = ggplot2::element_blank())
		)

		suppressWarnings(
			p3 <- ggplot2::ggplot(stats, ggplot2::aes(x = stats$method, y = stats$block_mean)) +
			ggplot2::geom_bar(stat = "identity") + ggplot2::ylab("Block mean") +
			ggplot2::theme(axis.title.x = ggplot2::element_blank(), axis.text.x = ggplot2::element_text(angle = 45, hjust = 1))
		)

		cm = cmp_calc_concordance(clt2)
		p4 = grid.grabExpr(draw(Heatmap(cm, col = colorRamp2(c(0, 0.5, 1), c("blue", "white", "red")), name = "Concordance", column_names_rot = 45)))

		suppressWarnings(print(cowplot::plot_grid(
			cowplot::plot_grid(p0, p4, ncol = 1), 
			cowplot::plot_grid(p1, p2, p3, nrow = 3, align = "v", axis = "lr", rel_heights = c(1, 1, 1.5)),
			nrow = 1
		)))

	} else if(tolower(plot_type) == "heatmap") {
		pl = list()
		lgd = NULL

		for(i in seq_along(methods)) {
			if(any(is.na(clt[[i]]))) {
				pl[[i]] = textGrob(qq("@{methods[i]}\nan error occured."))
			} else {
				pl[[i]] = grid.grabExpr(ht <- ht_clusters(mat, clt[[i]], draw_word_cloud = FALSE, 
					column_title = qq("@{nrow(mat)} terms clustered by '@{methods[i]}'"),
					show_heatmap_legend = FALSE))
				lgd1 = color_mapping_legend(ht@ht_list[[1]]@matrix_color_mapping, plot = FALSE,
					legend_direction = "horizontal", title_position = "lefttop")
				lgd2 = Legend(labels = "Small clusters (size < 5)", legend_gp = gpar(fill = "darkgreen"))
				lgd = packLegend(lgd1, lgd2)
			}
		}

		n_all = sapply(clt, function(x) {
			if(any(is.na(x))) {
				NA
			} else {
				length(unique(x))
			}
		})
		n_big = sapply(clt, function(x) {
			if(any(is.na(x))) {
				NA
			} else {
				tb = table(x)
				sum(tb >= 5)
			}
		})

		tb = data.frame(Method = methods, "All clusters" = n_all, "Large clusters (size \u2265 5)" = n_big, check.names = FALSE)

		check_pkg("gridExtra", bioc = FALSE)

		pl[[length(pl) + 1]] = gridExtra::tableGrob(tb, rows = NULL)

		np = length(pl)

		ncol = ceiling(np/nrow)
		grid.newpage()
		pushViewport(viewport(layout = grid.layout(nrow = nrow, ncol = ncol)))
		for(i in 1:np) {
			ir = ceiling(i/ncol)
			ic = i %% ncol; if(ic == 0) ic = ncol
			pushViewport(viewport(layout.pos.row = ir, layout.pos.col = ic))
			if(i < np) {
				grid.draw(pl[[i]])
			} else {
				pushViewport(viewport(x = unit(0, "npc") + unit(2, "mm"), y = unit(1, "npc") - unit(1, "cm"),
					width = sum(pl[[i]]$widths), height = sum(pl[[i]]$heights),
					just = c("left", "top")))
				grid.draw(pl[[i]])
				grid.text("Number of clusters", y = unit(1, "npc") + unit(2.5, "mm"), just = "bottom", gp = gpar(fontsize = 14))
				popViewport()

				if(!is.null(lgd)) {
					draw(lgd, x = unit(0, "npc") + unit(2, "mm"), y = unit(1, "npc") - sum(pl[[i]]$heights) - unit(1.5, "cm"), just = c("left", "top"))
				}
			}
			popViewport()
		}
	}
}

cmp_calc_concordance = function(clt) {

	clt = lapply(clt, as.character)
	clt = as.data.frame(clt)

	concordance = function(cl1, cl2) {
		cl1 = as.vector(cl1)
		cl2 = as.vector(cl2)
		nle1 = length(unique(cl1))
		nle2 = length(unique(cl2))

		if(nle1 > nle2) {
			cl2 = relabel_class(cl2, cl1, return_map = FALSE)
		} else {
			cl1 = relabel_class(cl1, cl2, return_map = FALSE)
		}

		sum(cl1 == cl2)/length(cl1)
	}

	n = length(clt)
	mm = matrix(1, nrow = n, ncol = n)
	rownames(mm) = names(clt)
	colnames(mm) = names(clt)
	for(i in seq(1, (n-1))) {
		for(j in seq(i+1, n)) {
			mm[i, j] = concordance(clt[[i]], clt[[j]])
			mm[j, i] = mm[i, j]
		}
	}

	mm
}

cmp_calc_stats = function(mat, clt) {
	x = data.frame("diff_s" = vapply(clt, function(x) difference_score(mat, x), 0),
		 "n_all" = vapply(clt, function(x) length(table(x)), 0),
	     "n_large" = vapply(clt, function(x) {tb = table(x); sum(tb >= 5)}, 0),
		 "block_mean" = vapply(clt, function(x) block_mean(mat, x), 0))
	return(x)
}

#' @rdname compare
#' @details
#' `compare_clustering_methods()` is basically a wrapper function of `cmp_make_clusters()` and `cmp_make_plot()`.
#'
#' @return
#' `compare_clustering_methods()` returns no value.
#' @export
#' @examples
#' \donttest{
#' mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
#'     package = "simplifyEnrichment"))
#' compare_clustering_methods(mat)
#' compare_clustering_methods(mat, plot_type = "heatmap")
#' }
compare_clustering_methods = function(mat, method = setdiff(all_clustering_methods(), "mclust"),
	plot_type = c("mixed", "heatmap"), nrow = 3, verbose = TRUE) {

	clt = cmp_make_clusters(mat, method, verbose = verbose)

	plot_type = match.arg(plot_type)[1]
	cmp_make_plot(mat, clt, plot_type = plot_type, nrow = nrow)
}

#' Partition the matrix
#'
#' @param mat The submatrix in the binary cut clustering process.
#' @param n_repeats Number of repeated runs of k-means clustering.
#'
#' @details
#' These functions can be set to the `partition_fun` argument in [`binary_cut()`].
#' 
#' `partition_by_kmeans()`: Since k-means clustering brings randomness, this function performs
#' k-means clustering several times (controlled by `n_repeats`) and uses the final consensus partitioning results.
#' 
#' @export
#' @import clue
#' @rdname node_partition
#' @return
#' All partitioning functions split the matrix into two groups and return a categorical vector of
#' labels of 1 and 2.
partition_by_kmeans = function(mat, n_repeats = 10) {
    partition_list = lapply(seq_len(n_repeats), function(i) {
        as.cl_hard_partition(kmeans(mat, 2))
    })
    partition_list = cl_ensemble(list = partition_list)
    partition_consensus = cl_consensus(partition_list)
    cl = as.vector(cl_class_ids(partition_consensus))
    if(length(unique(cl)) == 1) {
    	cl = partition_list[[1]]$.Data$cluster
    }
    cl
}

#' @details
#' `partition_by_pam()`: The clustering is performed by [`cluster::pam()`] with the `pamonce` argument set to 5.
#' 
#' @export
#' @importFrom cluster pam
#' @rdname node_partition
partition_by_pam = function(mat) {
    if(nrow(mat) > 10) {
        fit = pam(mat, 2, pamonce = 5)
    } else {
        fit = pam(mat, 2)
    }
    
    fit$clustering
}


#' @details
#' `partition_by_hclust()`: The "ward.D2" clusering method was used.
#'
#' @export
#' @rdname node_partition
partition_by_hclust = function(mat) {
    cutree(hclust(dist(mat), method = "ward.D2"), 2)
}

#' @details
#' `partition_by_kmeanspp()`: It uses the kmeanspp method from the **flexclust** package.
#' 
#' @export
#' @rdname node_partition
partition_by_kmeanspp = function(mat) {
    check_pkg("flexclust", bioc = FALSE)
    
    cl = flexclust::kcca(mat, k = 2, 
        family = flexclust::kccaFamily("kmeans"),
        control = list(initcent = "kmeanspp"))@cluster
    cl
}

#' Interactively visualize the similarity heatmap
#'
#' @param mat A similarity matrix.
#' @param cl Cluster labels inferred from the similarity matrix, e.g. from [`cluster_terms()`] or [`binary_cut()`].
#' @return A shiny application.
#' @export
#' @import GO.db
#' @examples
#' if(interactive()) {
#'     mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", 
#'         package = "simplifyEnrichment"))
#'     cl = binary_cut(mat)
#'     export_to_shiny_app(mat, cl)
#' }
export_to_shiny_app = function(mat, cl = binary_cut(mat)) {

	check_pkg("shiny")
	check_pkg("shinydashboard")
	check_pkg("InteractiveComplexHeatmap", bioc = TRUE)

	if(!all(is_GO_id(sample(rownames(mat), min(10, nrow(mat)))))) {
		is_GO = FALSE
	} else {
		is_GO = TRUE
	}

	get_go_term = function(go_id) {
	    term = suppressMessages(AnnotationDbi::select(GO.db, keys = go_id, columns = "TERM")$TERM)
	    term[is.na(term)] = "NA"
	    term
	}

	version = packageDescription('simplifyEnrichment', fields = "Version")

	body = shinydashboard::dashboardBody(
		shiny::div(
			shiny::htmlOutput("summary"),
			shiny::p(shiny::HTML("You can click on the similarity heatmap or select an area from it. If you cannot precisely select a cluster from the heatmap, you can manually remove extra rows and columns from the selected sub-heatmap with the tool <i>'Configure sub-heatmap'</i> (the first icon) under the sub-heatmap in <i>'Sub-Heatmap'</i> panel.")),
			style = "border: 1px solid #3c8dbc; border-radius: 3px; padding: 10px; font-size: 1.2em; margin-bottom: 10px; background-color: white;"
	    ),
	    shiny::fluidRow(
	        shiny::column(width = ifelse(is_GO, 6, 4),
	            shinydashboard::box(title = qq("@{ifelse(is_GO, 'GO', 'Functional term')} similarity heatmap"), width = NULL, solidHeader = TRUE, status = "primary",
	                InteractiveComplexHeatmap::originalHeatmapOutput("ht", width = ifelse(is_GO, 700, 500), height = 450, containment = TRUE)
	            )
	        ),
	        shiny::column(width = 4,
	            shinydashboard::box(title = "Sub-heatmap", width = NULL, solidHeader = TRUE, status = "primary",
	                InteractiveComplexHeatmap::subHeatmapOutput("ht", title = NULL, containment = TRUE)
	            ),
	            shinydashboard::box(title = "Output", width = NULL, solidHeader = TRUE, status = "primary",
	                InteractiveComplexHeatmap::HeatmapInfoOutput("ht", title = NULL, width = "100%")
	            ),
	            if(is_GO) {
		            shinydashboard::box(title = "GO description", width = NULL, solidHeader = TRUE, status = "primary",
		                shiny::uiOutput("go_desc")
		            )
		        } else {
		        	NULL
		        }
	        )
	    ),
	    shiny::hr(style="border-top: 1px solid #3c8dbc"),
	    shiny::p(shiny::HTML(qq("Generated by <a href=\"https://github.com/jokergoo/simplifyEnrichment\" target=\"_blank\">simplifyEnrichment</a> version @{version}")))
	)

	sidebar = shinydashboard::dashboardSidebar(
		shiny::numericInput("min_term", "Min #terms to form a cluster:", value = round(nrow(mat)*0.01), min = 1),
		shiny::radioButtons("order_by_size", "Order by size?", choices = c("yes" = 1, "no" = 2), inline = TRUE),
		if(is_GO) shiny::textInput("exclude_words", "Exclude words:", placeholder = "Multiple words separate by \",\"") else NULL,
		if(is_GO) shiny::numericInput("max_words", "Max #words on each cloud:", value = 10, min = 1) else NULL,
		shiny::actionButton("update", "Update heatmap"),
		shiny::tags$style(shiny::HTML("
            .left-side, .main-sidebar {
                padding-top:15px;
            }
        "))
	)

	ui = shinydashboard::dashboardPage(
		title = "simplifyEnrichment Shiny app",
	    shinydashboard::dashboardHeader(disable = TRUE),
	    sidebar,
	    body
	)

	e = new.env(parent = emptyenv())
	if(is_GO) {
		click_action = function(df, output) {
			col_fun = e$col_fun
		    output[["go_desc"]] = shiny::renderUI({
		        if(!is.null(df)) {
		            go_id1 = rownames(mat)[df$row_index]
		            go_id2 = colnames(mat)[df$column_index]

		            oe = try(term1 <- get_go_term(go_id1), silent = TRUE)
	            if(inherits(oe, "try-error")) {
	                term1 = ""
	            }
	            oe = try(term2 <- get_go_term(go_id2), silent = TRUE)
	            if(inherits(oe, "try-error")) {
	                term2 = ""
	            }

	            v = mat[go_id1, go_id2]
	            col = col_fun(v)

	            shiny::HTML(qq(
"<b>GO similarity</b>
<p>@{sprintf('%.3f', v)}  <span style='background-color:@{col};width=10px;'>&nbsp;&nbsp;&nbsp;&nbsp;</span></p>
<b>Row GO ID</b>
<p><a href='http://amigo.geneontology.org/amigo/term/@{go_id1}' target='_blank'>@{go_id1}</a>: @{term1}</p>
<b>Column GO ID</b>
<p><a href='http://amigo.geneontology.org/amigo/term/@{go_id2}' target='_blank'>@{go_id2}</a>: @{term2}</p>
"))
		        }
		    })
		}

		brush_action = function(df, output) {
		    output[["go_desc"]] = shiny::renderUI({
		        if(!is.null(df)) {
		            row_index = unique(unlist(df$row_index))
		            column_index = unique(unlist(df$column_index))
		            go_id1 = rownames(mat)[row_index]
		            go_id2 = colnames(mat)[column_index]
	           		go_id = union(go_id1, go_id2)

		            go_text = qq("<p><a href='http://amigo.geneontology.org/amigo/term/@{go_id}' target='_blank'>@{go_id}</a>: @{get_go_term(go_id)}</p>\n")
		            shiny::HTML(qq(
"<b>A list of @{length(go_id)} GO IDs</b>
@{go_text}"))
		        }
		    })
		}
	} else {
		click_action = NULL
		brush_action = NULL
	}

	server = function(input, output, session) {

		shiny::observeEvent(input$update, {

			min_term = input$min_term
			order_by_size = ifelse(input$order_by_size == "1", TRUE, FALSE)
			if(is_GO) {
				exclude_words = tolower(strsplit(input$exclude_words, "\\s*,\\s*")[[1]])
				max_words = input$max_words
			} else {
				exclude_words = character(0)
				max_words = 10
			}

			ht = ht_clusters(mat, cl, word_cloud_grob_param = list(max_width = 80), 
				min_term = min_term, order_by_size = order_by_size,
				exclude_words = exclude_words, max_words = max_words, run_draw = FALSE) + NULL
			
			e$col_fun = ht@ht_list[[1]]@matrix_color_mapping@col_fun
			n = nrow(mat)
			tb = table(cl)
			ng = length(tb)
			ng_small = sum(tb < min_term)

			output$summary = shiny::renderUI({
				shiny::p(shiny::HTML(qq("This Shiny app visualizes a similarity matrix with <b>@{nrow(mat)}</b> @{ifelse(is_GO, 'GO', 'functional')} terms. The terms are partitioned into <b>@{ng - ng_small}</b> large clusters (size &#8805;  @{min_term}, those with word cloud annotations) and <b>@{ng_small}</b> small clusters (size < @{min_term}).")))
			})

		    InteractiveComplexHeatmap::makeInteractiveComplexHeatmap(input, output, session, ht,
		        click_action = click_action, brush_action = brush_action)
		}, ignoreNULL = FALSE)
	}

	shiny::shinyApp(ui, server)
}

relabel_class = function (class, ref, full_set = union(class, ref), return_map = TRUE) {
    if(!requireNamespace("clue")) {
        stop_wrap("Package 'clue' should be installed.")
    }

    md = mode(class)
    class = as.character(class)
    ref = as.character(ref)
    full_set = as.character(full_set)
    all_class = union(class, ref)
    n = length(all_class)
    m = matrix(0, nrow = n, ncol = n, dimnames = list(all_class, all_class))
    tb = table(class, ref)
    m[rownames(tb), colnames(tb)] = tb
    imap = clue::solve_LSAP(m, maximum = TRUE)
    map = structure(rownames(m)[imap], names = rownames(m))
    map = map[unique(class)]
    unmapped = setdiff(setdiff(full_set, class), names(map))
    if (length(unmapped)) {
        map = c(map, structure(unmapped, names = unmapped))
    }
    df = data.frame(class = class, adjusted = map[class], ref = ref, 
        stringsAsFactors = FALSE)
    attr(map, "df") = df
    if (return_map) {
        return(map)
    }
    else {
        return(as(df$adjusted, md))
    }
}

stop_wrap = function (...) {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    stop(x, call. = FALSE)
}

message_wrap = function (...)  {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    message(x)
}


#' @importFrom utils flush.console install.packages packageDescription
check_pkg = function(pkg, bioc = FALSE) {
    if(requireNamespace(pkg, quietly = TRUE)) {
        return(NULL)
    } else {

        if(!interactive()) {
            if(bioc) {
                stop_wrap(qq("You need to manually install package '@{pkg}' from Bioconductor."))
            } else {
                stop_wrap(qq("You need to manually install package '@{pkg}' from CRAN."))
            }
        }

        if(bioc) {
            answer = readline(qq("Package '@{pkg}' is required but not installed. Do you want to install it from Bioconductor? [y|n] "))
        } else {
            answer = readline(qq("Package '@{pkg}' is required but not installed. Do you want to install it from CRAN? [y|n] "))
        }

        if(bioc) {
            if(tolower(answer) %in% c("y", "yes")) {
                if(!requireNamespace("BiocManager", quietly = TRUE)) {
                    install.packages("BiocManager")
                }
                BiocManager::install(pkg)
            } else {
                stop_wrap(qq("You need to manually install package '@{pkg}' from Bioconductor."))
            }
        } else {
            if(tolower(answer) %in% c("y", "yes")) {
                install.packages(pkg)
            } else {
                stop_wrap(qq("You need to manually install package '@{pkg}' from CRAN."))
            }
        }
    }
}


is_GO_id = function(x) {
    grepl("^GO:[0-9]+$", x)
}

#' A simplified way to visualize enrichment in GO clusters
#'
#' @param go_id A vector of GO IDs.
#' @param value A list of numeric value associate with `go_id`. We suggest to use `-log10(p.adjust)` or `-log2(fold enrichment)` as the values.
#' @param aggregate Function to aggregate values in each GO cluster.
#' @param method Method for clustering the matrix. See [`cluster_terms()`].
#' @param control A list of parameters for controlling the clustering method, passed to [`cluster_terms()`].
#' @param verbose Whether to print messages.
#' @param axis_label X-axis label.
#' @param title Title for the whole plot.
#' @param legend_title Title for the legend.
#' @param min_term Minimal number of functional terms in a cluster. All the clusters
#'     with size less than `min_term` are all merged into one separated cluster in the heatmap.
#' @param stat Type of value for mapping to the font size of keywords in the word clouds. There are two options:
#'       "count": simply number of keywords; "pvalue": enrichment on keywords is performed (by fisher's exact test) and -log10(pvalue) is used to map to font sizes.
#' @param min_stat Minimal value for `stat` for selecting keywords.
#' @param exclude_words Words that are excluded in the word cloud.
#' @param max_words Maximal number of words visualized in the word cloud.
#' @param word_cloud_grob_param A list of graphic parameters passed to `word_cloud_grob`.
#' @param fontsize_range The range of the font size. The value should be a numeric vector with length two.
#'       The font size interpolation is linear.
#' @param bg_gp Graphics parameters for controlling word cloud annotation background.
#'
#' @details
#' There are several other ways to specify GO IDs and the associated values.
#'
#' 1. specify `value` as a named vector where GO IDs are the names.
#' 2. specify `value` as a list of numeric named vectors. In this case, `value` contains multiple enrichment results.
#' 
#' Please refer to \url{https://jokergoo.github.io/2023/10/02/simplified-simplifyenrichment-plot/} for more examples of this function.
#' @export
summarizeGO = function(go_id, value = NULL, aggregate = mean, 
	method = "binary_cut", control = list(), verbose = TRUE, 
	axis_label = "Value", title = "", legend_title = axis_label,

	min_term = round(nrow(mat)*0.01), 
	stat = "pvalue", 
	min_stat = ifelse(stat == "count", 5, 0.05),
	exclude_words = character(0), 
	max_words = 6,
	word_cloud_grob_param = list(), 
	fontsize_range = c(4, 16), 
	bg_gp = gpar(fill = "#DDDDDD", col = "#AAAAAA")

	) {

	if(missing(go_id)) {
		if(is.atomic(value)) {
			go_id = names(value)
		} else if(is.list(value)) {
			go_id = unique(unlist(lapply(value, names)))
			if(length(go_id) == 0) {
				stop("If `value` is set as list, each element vector should be a named vector.")
			}
			vv = matrix(0, nrow = length(go_id), ncol = length(value))
			rownames(vv) = go_id
			colnames(vv) = names(value)
			for(i in seq_along(value)) {
				vv[names(value[[i]]), i] = value[[i]]
			}
			value = vv
		}
	}

	if(is.null(value)) {
		value = rep(1, length(go_id))
		aggregate = sum
		axis_label = "Number of terms"
	}

	if(is.vector(value)) {
		value = cbind(value)
	}
	rownames(value) = go_id
	if(is.null(colnames(value))) {
		colnames(value) = paste0("C", seq_len(ncol(value)))
	}
	mat = GO_similarity(go_id)

	cl = do.call(cluster_terms, list(mat = mat, method = method, verbose = verbose, control = control))
	
	value = value[rownames(mat), , drop = FALSE]
	go_id = rownames(mat)

	cl = as.vector(cl)
	cl_tb = table(cl)
	cl[as.character(cl) %in% names(cl_tb[cl_tb < min_term])] = 0
	cl = factor(cl, levels = c(setdiff(sort(cl), 0), 0))

	l = cl != 0
	cl = cl[l]
	cl = as.vector(cl)
	go_id = go_id[l]
	value = value[l, , drop = FALSE]

	align_to = split(seq_along(cl), cl)
	go_id = split(go_id, cl)
	n = length(align_to)

	v2 = tapply(seq_along(cl), cl, function(ind) {
		apply(value[ind, , drop = FALSE], 2, aggregate)
	}, simplify = FALSE)
	v2 = do.call(rbind, v2)

	gbl = anno_word_cloud_from_GO(align_to, go_id, return_gbl = TRUE,
		stat = stat, min_stat = min_stat,
		exclude_words = exclude_words, max_words = max_words, word_cloud_grob_param = word_cloud_grob_param, 
		fontsize_range = fontsize_range, bg_gp = bg_gp)


	gbl_h = lapply(gbl, function(x) convertHeight(grobHeight(x), "cm") + unit(10, "pt"))
	gbl_h = do.call(unit.c, gbl_h)

	gbl_w = lapply(gbl, function(x) convertWidth(grobWidth(x), "cm"))
	gbl_w = do.call(unit.c, gbl_w)
	gbl_w = max(gbl_w) + unit(10, "pt")

	gap = rep( (unit(1, "npc") - sum(gbl_h))/(n-1), n - 1)
	gap = unit.c(unit(0, "mm"), gap)

	if(ncol(v2) > 1) {
		size_fun = generate_size_fun(range(v2), c(2, 20))
		size_breaks = grid.pretty(range(v2), 3)
		lgd = Legend(title = legend_title, at = size_breaks, type = "points", 
			size = unit(size_fun(size_breaks), "pt"), pch = 16, legend_gp = gpar(col = "#888888"),
			row_gap = unit(6, "pt"), background = "white")
	}
	
	grid.newpage()
	pushViewport(viewport(x = unit(5, "mm"), y = unit(1.6, "cm"), width = unit(1, "npc") - unit(1, "cm"), height = unit(1, "npc") - unit(3, "cm"), just = c("left", "bottom")))
	for(i in seq_along(gbl)) {
		y = sum(gbl_h[seq_len(i)]) + sum(gap[seq_len(i)]) - gbl_h[i]*0.5
		pushViewport(viewport(x = 0, y = y, 
			width = gbl_w, height = gbl_h[i], just = c("left")))
		grid.rect(gp = gpar(fill = "#EEEEEE"))
		gb = gbl[[i]]
	    gb$vp$x = gb$vp$width*0.5 + unit(5, "pt")
	    grid.draw(gb)
		popViewport()

		if(ncol(v2) == 1) {
			if(all(v2 > 0)) {
				pushViewport(viewport(x = gbl_w + unit(5, "pt"), y = y, width = unit(1, "npc") - gbl_w, height = gbl_h[i],
					xscale = c(0, max(v2)), just = c("left")))
			} else {
				pushViewport(viewport(x = gbl_w + unit(5, "pt"), y = y, width = unit(1, "npc") - gbl_w, height = gbl_h[i],
					xscale = range(v2), just = c("left")))
			}

			grid.rect(0, 0.5, width = unit(v2[i], "native"), height = unit(6, "mm"), just = c("left"),
				gp = gpar(fill = "#CCCCCC"))

			if(i == 1) {
				gb = xaxisGrob(gp = gpar(fontsize = 8))
				grid.draw(gb)
				grid.text(axis_label, 0.5, -unit(25, "pt"), just = "top")
			}
			popViewport()
		} else {
			pushViewport(viewport(x = gbl_w + unit(5, "pt"), y = y, width = unit(1, "npc") - gbl_w - grobWidth(lgd@grob) - unit(10, "pt"), height = gbl_h[i],
					xscale = c(0.5, ncol(v2) + 0.5), just = c("left")))
			grid.points(x = unit(1:ncol(v2), "native"), y = rep(0.5, ncol(v2)), pch = 16, gp = gpar(col = "#888888"), size = unit(size_fun(v2[i, ]), "pt"))
			if(i == 1) {
				grid.text(colnames(value), x = unit(1:ncol(v2), "native"), y = rep(unit(-4, "pt"), ncol(v2)), just = "top", gp = gpar(fontsize = 8))
				grid.text(axis_label, 0.5, -unit(20, "pt"), just = "top")
			}
			popViewport()
		}

	}
	grid.text(title, y = unit(1, "npc") + unit(10, "pt"), just = "bottom", gp = gpar(fontsize = 14))

	if(ncol(v2) > 1) {
		draw(lgd, x = unit(1, "npc"), y = unit(0.5, "npc"), just = c("right"))
	}
	popViewport()

}

generate_size_fun = function(rg, size) {
	function(x) {
		x[x < rg[1]] = rg[1]
		x[x > rg[2]] = rg[2]

		(x - rg[1]) * (size[2] - size[1])/(rg[2] - rg[1]) + size[1]
	}
}

#' Visualize the similarity matrix and the clustering
#'
#' @param mat A similarity matrix.
#' @param cl Cluster labels inferred from the similarity matrix, e.g. from [`cluster_terms()`] or [`binary_cut()`].
#' @param dend Used internally.
#' @param col A vector of colors that map from 0 to the 97.5^th percentile of the similarity values. The value can also be a color mapping function
#'      generated by [`circlize::colorRamp2()`].
#' @param draw_word_cloud Whether to draw the word clouds.
#' @param min_term Minimal number of functional terms in a cluster. All the clusters
#'     with size less than `min_term` are all merged into one separated cluster in the heatmap.
#' @param order_by_size Whether to reorder clusters by their sizes. The cluster
#'      that is merged from small clusters (size < `min_term`) is always put to the bottom of the heatmap.
#' @param stat Type of value for mapping to the font size of keywords in the word clouds. There are two options:
#'       "count": simply number of keywords; "pvalue": enrichment on keywords is performed (by fisher's exact test) and -log10(pvalue) is used to map to font sizes.
#' @param min_stat Minimal value for `stat` for selecting keywords.
#' @param exclude_words Words that are excluded in the word cloud.
#' @param max_words Maximal number of words visualized in the word cloud.
#' @param word_cloud_grob_param A list of graphic parameters passed to [`word_cloud_grob()`].
#' @param fontsize_range The range of the font size. The value should be a numeric vector with length two.
#'       The font size interpolation is linear.
#' @param bg_gp Graphics parameters for controlling word cloud annotation background.
#' @param column_title Column title for the heatmap.
#' @param ht_list A list of additional heatmaps added to the left of the similarity heatmap.
#' @param use_raster Whether to write the heatmap as a raster image.
#' @param run_draw Internally used.
#' @param ... Other arguments passed to [`ComplexHeatmap::draw,HeatmapList-method`].
#'
#' @return
#' A [`ComplexHeatmap::HeatmapList-class`] object.
#' @export
#' @import grDevices
#' @examples
#' \donttest{
#' mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
#'     package = "simplifyEnrichment"))
#' cl = binary_cut(mat)
#' ht_clusters(mat, cl, word_cloud_grob_param = list(max_width = 80))
#' ht_clusters(mat, cl, word_cloud_grob_param = list(max_width = 80),
#'     order_by_size = TRUE)
#' }
ht_clusters = function(
	mat, 
	cl, 
	dend = NULL, 
	col = c("white", "red"),

	# arguments that control the word cloud annotation
	draw_word_cloud = TRUE, 
	min_term = round(nrow(mat)*0.01), 
	order_by_size = FALSE, 
	stat = "pvalue", 
	min_stat = ifelse(stat == "count", 5, 0.05),
	exclude_words = character(0), 
	max_words = 10,
	word_cloud_grob_param = list(), 
	fontsize_range = c(4, 16), 
	bg_gp = gpar(fill = "#DDDDDD", col = "#AAAAAA"),

	# arguments that control the heatmaps
	column_title = NULL, 
	ht_list = NULL, 
	use_raster = TRUE, 
	run_draw = TRUE,
	...) {

	if(is.function(col)) {
		col_fun = col
	} else {
		if(length(col) == 1) col = c("white", rgb(t(col2rgb(col)), maxColorValue = 255))
		col_fun = colorRamp2(seq(0, quantile(mat[mat > 0], 0.975), length = length(col)), col)
	}
	if(!is.null(dend)) {
		ht = Heatmap(mat, col = col_fun,
			name = "Similarity", column_title = column_title,
			show_row_names = FALSE, show_column_names = FALSE,
			cluster_rows = dend, cluster_columns = dend, 
			show_row_dend = TRUE, show_column_dend = FALSE,
			row_dend_width = unit(4, "cm"),
			border = "#404040", row_title = NULL,
			use_raster = use_raster)
		draw(ht)
		return(invisible(NULL))
	} else {
		if(inherits(cl, "try-error")) {
			grid.newpage()
			pushViewport(viewport())
			grid.text("Clustering has an error.")
			popViewport()
			return(invisible(NULL))
		}

		# if(!is.factor(cl)) cl = factor(cl, levels = unique(cl))
		cl = as.vector(cl)
		cl_tb = table(cl)
		cl[as.character(cl) %in% names(cl_tb[cl_tb < min_term])] = 0
		cl = factor(cl, levels = c(setdiff(sort(cl), 0), 0))

		if(order_by_size) {
			cl = factor(cl, levels = c(setdiff(names(sort(table(cl), decreasing = TRUE)), 0), 0))
		}
		# od2 = order.dendrogram(dend_env$dend)
		od2 = unlist(lapply(levels(cl), function(le) {
			l = cl == le
			if(sum(l) <= 1) {
				return(which(l))
			} else {
				mm = mat[l, l, drop = FALSE]
				which(l)[hclust(stats::dist(mm))$order]
			}
		}))
		ht = Heatmap(mat, col = col_fun,
			name = "Similarity", column_title = column_title,
			show_row_names = FALSE, show_column_names = FALSE,
			show_row_dend = FALSE, show_column_dend = FALSE,
			row_order = od2, column_order = od2,
			border = "#404040", row_title = NULL,
			use_raster = use_raster) + NULL

		if(is.null(rownames(mat))) {
			draw_word_cloud = FALSE
		} else if(!grepl("^GO:[0-9]+$", rownames(mat)[1]) & draw_word_cloud) {
			draw_word_cloud = FALSE
		}

		if(draw_word_cloud) {
			go_id = rownames(mat)

			align_to = split(seq_along(cl), cl)
			go_id = split(go_id, cl)

			align_to = align_to[names(align_to) != "0"]
			go_id = go_id[names(go_id) != "0"]

			if(length(align_to)) {
				ht = ht + rowAnnotation(keywords = anno_word_cloud_from_GO(align_to, go_id = go_id, stat = stat, min_stat = min_stat,
					exclude_words = exclude_words, max_words = max_words, word_cloud_grob_param = word_cloud_grob_param, 
					fontsize_range = fontsize_range, bg_gp = bg_gp))
			} else {
				ht = ht + Heatmap(ifelse(cl == "0", "< 5", ">= 5"), col = c("< 5" = "darkgreen", ">= 5" = "white"), width = unit(1, "mm"),
					heatmap_legend_param = list(title = "", at = "< 5", labels = "Small clusters"),
					show_column_names = FALSE)
			}
		} else {
			if(any(cl == "0")) {
				ht = ht + Heatmap(ifelse(cl == "0", "< 5", ">= 5"), col = c("< 5" = "darkgreen", ">= 5" = "white"), width = unit(1, "mm"),
					heatmap_legend_param = list(title = "", at = "< 5", labels = "Small clusters"),
					show_column_names = FALSE)
			}
		}
	}

	ht@ht_list[[1]]@heatmap_param$post_fun = function(ht) {

		decorate_heatmap_body("Similarity", {
			grid.rect(gp = gpar(fill = NA, col = "#404040"))
			cl = factor(cl, levels = unique(cl[od2]))
			tbcl = table(cl)
			ncl = length(cl)
			x = cumsum(c(0, tbcl))/ncl
			grid.segments(x, 0, x, 1, default.units = "npc", gp = gpar(col = "#404040"))
			grid.segments(0, 1 - x, 1, 1 - x, default.units = "npc", gp = gpar(col = "#404040"))
		})
	}

	gap = unit(2, "pt")
	if(!is.null(ht_list)) {
		if(is.function(ht_list)) {
			ht_list = ht_list(align_to)
		}
		n = length(ht_list)
		ht = ht_list + ht
		gap = unit.c(unit(rep(2, n), "mm"), gap)
	}
	
	if(run_draw) {
		ht = draw(ht, main_heatmap = "Similarity", gap = gap, ...)
	}
	return(invisible(ht))
}

#' Scale font size
#'
#' @param x A numeric vector.
#' @param rg The range.
#' @param fs Range of the font size.
#'
#' @details
#' It is a linear interpolation.
#'
#' @return
#' A numeric vector.
#' @export
#' @examples
#' x = runif(10, min = 1, max = 20)
#' # scale x to fontsize 4 to 16.
#' scale_fontsize(x)
scale_fontsize = function(x, rg = c(1, 30), fs = c(4, 16)) {
	k = (fs[2] - fs[1])/(rg[2] - rg[1]) 
	b = fs[2] - k*rg[2]
	y = k*x + b
	y[y < fs[1]] = fs[1]
	y[y > fs[2]] = fs[2]
	round(y)
}

dend_max_depth = function(dend) {
	max(unlist(dend_node_apply(dend, function(d, index) {
		length(index) + 1
	})))
}

#' Area above the eCDF curve
#'
#' @param x A vector of similarity values.
#'
#' @details
#' Denote `F(x)` as the eCDF (empirical Cumulative Distribution Function) of the similarity vector `x`, 
#' this function calculates the area above the eCDF curve, which is `1 - \int_0^1 F(x)dx`.
#'
#' @returns
#' A numeric value.
area_above_ecdf = function(x) { 
	f = ecdf(x)
	i = 1:100/100
	1 - sum(1/100*f(i))
}

# cluster the similarity matrix and assign scores to nodes
# two scores attached to each ndoe
# - score: the original score
# - score2: the score which have checked the children nodes' scores

#' @import stats
cluster_mat = function(mat, value_fun = area_above_ecdf, partition_fun = partition_by_pam, cutoff = 0.85) {

	dend = NULL

	dend_ind_list = list(NULL)
	mat_ind_list = list(seq_len(nrow(mat)))

	# breadth-first
	while(1) {

		if(length(mat_ind_list) == 0) break

		mat_ind_list2 = list()
		dend_ind_list2 = list()

		n = length(mat_ind_list)
		for(i in seq_len(n)) {
			mat_ind = mat_ind_list[[i]]
			dend_ind = dend_ind_list[[i]]

			lt = .cluster_mat(mat[mat_ind, mat_ind, drop = FALSE], value_fun, partition_fun)
			lt$attr$height = length(dend_ind)
			lt$attr$members = length(mat_ind)

			if(length(mat_ind) == 1) {
				if(is.null(dend_ind)) {
					dend = mat_ind
				} else {
					dend[[dend_ind]] = mat_ind
				}
			} else {
				if(is.null(dend_ind)) {
					dend = list()
				} else {
					dend[[dend_ind]] = list()
				}
			}
			if(is.null(dend_ind)) {
				attributes(dend) = lt$attr
			} else {
				attributes(dend[[dend_ind]]) = lt$attr
			}

			if(length(mat_ind) > 1) {
				mat_ind_list2 = c(mat_ind_list2, list(mat_ind[lt$ind1], mat_ind[lt$ind2]))
				dend_ind_list2 = c(dend_ind_list2, list(c(dend_ind, 1), c(dend_ind, 2)))
			}
		}

		mat_ind_list = mat_ind_list2
		dend_ind_list = dend_ind_list2
	}

	dend = rev(dend)

	max_d = dend_max_depth(dend)
	dend = dendrapply(dend, function(d) {
		attr(d, "height") = max_d - attr(d, "height")
		d
	})

	# to correctly assign midpoint for each node
	dend2 = as.dendrogram(as.hclust(dend))

	dend = edit_node(dend, function(d, index) {
		if(is.null(index)) {  # top node
			if(!is.leaf(d)) {
				attr(d, "midpoint") = attr(dend2, "midpoint")
			}
		} else {
			if(!is.leaf(d)) {
				attr(d, "midpoint") = attr(dend2[[index]], "midpoint")
			}
		}
		return(d)
	})

	dend = assign_score2(dend, cutoff)

	hash = digest::digest(list(mat, value_fun, partition_fun, cutoff))
	dend_env$dend = dend
	dend_env$hash = hash

	return(dend)
}

cluster_mat2 = function(mat, value_fun = median, partition_fun = partition_by_pam, cutoff = 0.85, return_dend = FALSE) {

	dend = NULL
	dend_env$dend = NULL

	dend_ind_list = list(NULL)
	mat_ind_list = list(seq_len(nrow(mat)))

	# breadth-first
	while(1) {

		if(length(mat_ind_list) == 0) break

		mat_ind_list2 = list()
		dend_ind_list2 = list()

		merged_dend_ind_list = list()

		n = length(mat_ind_list)
		for(i in seq_len(n)) {
			mat_ind = mat_ind_list[[i]]
			dend_ind = dend_ind_list[[i]]

			do_partitioning = TRUE
			if(length(mat_ind) == 1) {
				lt = .cluster_mat(mat[mat_ind, mat_ind, drop = FALSE], value_fun, partition_fun)
			} else {
				if(length(dend_ind) >= 3) {
					# parent node
					pd = dend[[dend_ind[seq(1, length(dend_ind)-2)]]]
					
					s2 = max(attr(pd[[1]], "score"), attr(pd[[2]], "score"))
					s = attr(pd, "score")
					if( min(nobs(pd[[1]]), nobs(pd[[2]]))/nobs(pd) < 0.1 ) {
						
					} else if(s > cutoff*0.8 && s < s2) {
						s = s2
					}

					if(s < cutoff) {
						do_partitioning = FALSE
						merged_dend_ind_list[[ length(merged_dend_ind_list) + 1 ]] = dend_ind[seq(1, length(dend_ind)-2)]
					} else {
						lt = .cluster_mat(mat[mat_ind, mat_ind, drop = FALSE], value_fun, partition_fun)
					}
				} else {
					lt = .cluster_mat(mat[mat_ind, mat_ind, drop = FALSE], value_fun, partition_fun)
				}
			}

			if(do_partitioning) {
				lt$attr$height = length(dend_ind)
				lt$attr$members = length(mat_ind)

				if(length(mat_ind) == 1) {
					if(is.null(dend_ind)) {
						dend = mat_ind
					} else {
						dend[[dend_ind]] = mat_ind
					}
				} else {
					if(is.null(dend_ind)) {
						dend = list()
					} else {
						dend[[dend_ind]] = list()
					}
				}
				if(is.null(dend_ind)) {
					attributes(dend) = lt$attr
				} else {
					attributes(dend[[dend_ind]]) = lt$attr
				}

				if(length(mat_ind) > 1) {
					mat_ind_list2 = c(mat_ind_list2, list(mat_ind[lt$ind1], mat_ind[lt$ind2]))
					dend_ind_list2 = c(dend_ind_list2, list(c(dend_ind, 1), c(dend_ind, 2)))
				}
			} else {
				# construct dendrogram for mat[mat_ind, mat_ind, drop = FALSE]
				dend[[dend_ind]] = mat_ind
				attributes(dend[[dend_ind]]) = list(
					label = "",
					leaf = TRUE,
					members = 1,
					height = 0,
					score = 0.5,
					class = "dendrogram"
				)
			}
		}

		mat_ind_list = mat_ind_list2
		dend_ind_list = dend_ind_list2

		merged_dend_ind_list = unique(merged_dend_ind_list)
		for(i in seq_along(merged_dend_ind_list)) {
			h = attr(dend[[ merged_dend_ind_list[[i]] ]], "height")
			dend[[ merged_dend_ind_list[[i]] ]] = unlist(dend[[ merged_dend_ind_list[[i]] ]])
			attributes(dend[[ merged_dend_ind_list[[i]] ]]) = list(
				label = "",
				leaf = TRUE,
				members = 1,
				height = h,
				score = 0.5,
				class = "dendrogram"
			)
		}
	}

	dend = rev(dend)

	lt = dend_node_apply(dend, function(d, ind) {
		if(is.leaf(d)) {
			as.vector(d) 
		} else {
			NULL
		}
	})
	lt = lt[!sapply(lt, is.null)]
	cl = numeric(nrow(mat))
	for(i in seq_along(lt)) {
		cl[lt[[i]]] = i
	}

	return(cl)
	
}

## bottom-up
assign_score2 = function(d, cutoff) {
	if(is.leaf(d)) {
		attr(d, "score2") = 0.5
		return(d)
	}
	if(length(d) == 0) {
		attr(d, "score2") = 0.5
		return(d)
	}
	# check the two child node
	if(is.null(attr(d[[1]], "score2"))) {
		d[[1]] = assign_score2(d[[1]], cutoff)
	}
	if(is.null(attr(d[[2]], "score2"))) {
		d[[2]] = assign_score2(d[[2]], cutoff)
	}

	s2 = max(attr(d[[1]], "score2"), attr(d[[2]], "score2"))
	# the node is assigned with its child nodes' score only if
	# 1. the size of the two children should not be too extremely different
	# 2. the score should not be too smaller than its child nodes' 
	s = attr(d, "score")
	if( min(nobs(d[[1]]), nobs(d[[2]]))/nobs(d) < 0.1 ) {
		attr(d, "score2")  = s
	} else if(s > cutoff*0.8 && s < s2) {
		attr(d, "score2") = s2
	} else {
		attr(d, "score2")  = s
	}
	return(d)
}

# assign current node and do partitioning to generate indices of two subsets
.cluster_mat = function(mat, value_fun, partition_fun) {
	nr = nrow(mat)

	if(nr == 1) {
		attr = list(
			label = "",
			leaf = TRUE,
			score = 0.5,
			class = "dendrogram"
		)
		return(list(attr = attr))
	}

	if(nrow(mat) == 2) {
		cl = c(1, 2)
	} else {
		oe = try(suppressWarnings(cl <- partition_fun(mat)), silent = TRUE)
		if(inherits(oe, "try-error")) {
			cl = rep(2, nr)
			cl[seq_len(ceiling(nr/2))] = 1
		}
	}

	l1 = cl == 1
	l2 = cl == 2
	if(mean(mat[l1, l1]) > mean(mat[l2, l2])) {
		l3 = l1
		l1 = l2
		l2 = l3
	}
	m11 = mat[l1, l1, drop = FALSE]
	if(nrow(m11) == 1) {
		x11 = 1
		x12 = value_fun(mat[l1, l2])
		x21 = value_fun(mat[l2, l1])
	} else {
		m11 = m11[ lower.tri(m11) | upper.tri(m11)]
		x11 = value_fun(m11)
		x12 = value_fun(mat[l1, l2])
		x21 = value_fun(mat[l2, l1])
	}
	m22 = mat[l2, l2, drop = FALSE]
	if(nrow(m22) == 1) {
		x22 = 1
	} else {
		m22 = m22[ lower.tri(m22) | upper.tri(m22)]
		x22 = value_fun(m22)
	}
	
	s = (x11 + x22)/(x11 + x12 + x21 + x22)
	if(is.na(s)) s = 1

	attr = list(
		members = NA,
		height = NA,
		score = s,
		class = "dendrogram"
	)
	return(list(attr = attr, ind1 = which(l1), ind2 = which(l2)))

}

cut_dend = function(dend, cutoff = 0.85, field = "score2", return = "cluster") {

	## add a split attribute on each node
	assign_child_node = function(d, split = NULL) {
		if(is.null(split)) {
			if(attr(d, field) >= cutoff) {
				attr(d, "split") = TRUE
				if(!is.leaf(d)) {
					d[[1]] = assign_child_node(d[[1]], NULL)
					d[[2]] = assign_child_node(d[[2]], NULL)
				}
			} else {
				attr(d, "split") = FALSE
				if(!is.leaf(d)) {
					d[[1]] = assign_child_node(d[[1]], FALSE)
					d[[2]] = assign_child_node(d[[2]], FALSE)
				}
			}
			
		} else {
			attr(d, "split") = split
			if(!is.leaf(d)) {
				d[[1]] = assign_child_node(d[[1]], split)
				d[[2]] = assign_child_node(d[[2]], split)
			}
		}
		d
	}

	dend = assign_child_node(dend)

	# if the top node
	if(!attr(dend, "split")) {
		dend2 = dendrapply(dend, function(d) {
			attr(d, "height") = 0
			d
		})

		if(return == "dend") {
			return(dend2)
		} else {
			return(rep(1, nobs(dend)))
		}
	}

	dend2 = edit_node(dend, function(d, index) {
		if(!attr(d, "split")) {
			attr(d, "height") = 0
		}
		d
	})

	if(return == "dend") {
		dend2
	} else {
		cl = cutree(as.hclust(dend2), h = 0.1)
		cl = factor(cl, levels = unique(cl[order.dendrogram(dend)]))
		return(cl)
	}
}

#' @importFrom circlize colorRamp2
render_dend = function(dend, field = "score2", cutoff = 0.85, align_leaf = FALSE, 
	depth = NULL, add_label = FALSE) {

	if(!is.null(depth)) {
		dend = edit_node(dend, function(d, index) {
			if(length(index) + 1 > depth) {
				d = dendrapply(d, function(d) {
					attr(d, "height") = 0
					d
				})
			}
			return(d)
		})
		return(dend)
	}

	# note: in dend2 branches that are not split all have height 0
	dend2 = cut_dend(dend, field = field, cutoff = cutoff, return = "dend")
	col_fun = colorRamp2(c(0.5, cutoff, 1), c("blue", "yellow", "red"))
	dend = edit_node(dend, function(d, index) {
		if(is.null(index)) {
			if(!is.leaf(d)) {
				s = attr(d, field)
				attr(d, "edgePar") = list(col = col_fun(s))
				
				if(attr(dend2, "height") > 0.5) {
					attr(d, "nodePar") = list(pch = 4, cex = 0.5)
					if(add_label) attr(d, "edgetext") = sprintf("%.2f", attr(d, "score"))
				}
			} else {
				attr(d, "edgePar") = list(col = "#DDDDDD")
			}
		} else {
			if(!is.leaf(d)) {
				s = attr(d, field)
				attr(d, "edgePar") = list(col = col_fun(s))	
				if(attr(dend2[[index]], "height") > 0.5) {
					if(length(index) > 1) {
						if(attr(dend2[[index[-length(index)]]], "height") > 0.5) {
							attr(d, "nodePar") = list(pch = 4, cex = 0.5)
							if(add_label) attr(d, "edgetext") = sprintf("%.2f", attr(d, "score"))
						}
					} else {
						if(attr(dend2, "height") > 0.5) {
							attr(d, "nodePar") = list(pch = 4, cex = 0.5)
							if(add_label) attr(d, "edgetext") = sprintf("%.2f", attr(d, "score"))
						}
					}
				}
			} else {
				attr(d, "edgePar") = list(col = "#DDDDDD")
			}
		}

		if(align_leaf) {
			if(is.leaf(d)) {
				attr(d, "height") = 0
			}
		}
		return(d)
	})
	
	attr(dend, "col_fun") = col_fun
	dend
}

dend_env = new.env()

#' @param dend A dendrogram object, used internally.
#' @param depth Depth of the recursive binary cut process.
#' @param dend_width Width of the dendrogram on the plot.
#' @param show_heatmap_legend Whether to show the heatmap legend.
#' @param ... Other arguments.
#'
#' @details
#' After the functions which perform clustering are executed, such as `simplifyGO()` or
#' `binary_cut()`, the dendrogram is temporarily saved and `plot_binary_cut()` directly
#' uses this dendrogram.
#'
#' @rdname binary_cut
#' @export
#' @importFrom digest digest
#' @import ComplexHeatmap
#' @import grid
#' @examples
#' \donttest{
#' mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", 
#'     package = "simplifyEnrichment"))
#' plot_binary_cut(mat, depth = 1)
#' plot_binary_cut(mat, depth = 2)
#' plot_binary_cut(mat)
#' }
plot_binary_cut = function(mat, value_fun = area_above_ecdf, cutoff = 0.85, 
	partition_fun = partition_by_pam, dend = NULL, dend_width = unit(3, "cm"),
	depth = NULL, show_heatmap_legend = TRUE, ...) {

	check_pkg("gridGraphics", bioc = FALSE)

	hash = digest(list(mat, value_fun, partition_fun, cutoff))

	# if it was already generated
	if(is.null(dend)) {
		if(identical(hash, dend_env$hash)) {
			dend = dend_env$dend
			if(se_opt$verbose) {
				message("use the cached dendrogram.")
			}
		} else {
			dend_env$hash = NULL
		}
	} else {
		dend_env$dend = NULL
		dend_env$hash = NULL
	}
	if(is.null(dend)) {
		if(se_opt$verbose) {
			message("create a new dendrogram.")
		}
		dend = cluster_mat(mat, value_fun = value_fun, partition_fun = partition_fun, cutoff = cutoff)
		dend_env$dend = dend
		dend_env$hash = hash
	}

	dend2 = render_dend(dend, cutoff = cutoff, depth = depth, ...)
	score_col_fun = attr(dend2, "col_fun")
	
	if(is.null(depth)) {
		cl = cut_dend(dend, cutoff = cutoff)
	} else {
		cl = cutree(as.hclust(dend2), h = 0.1)
	}
	
	od = order.dendrogram(dend2)
	
	col_fun = colorRamp2(c(0, quantile(mat, 0.95)), c("white", "red"))
	ht = Heatmap(mat, name = "Similarity", col = col_fun,
		show_row_names = FALSE, show_column_names = FALSE,
		cluster_rows = dend2, row_dend_width = dend_width,
		column_order = od,
		row_title = NULL, column_title = NULL,
		show_heatmap_legend = show_heatmap_legend,
		use_raster = TRUE) + NULL

	if(is.null(score_col_fun)) {
		draw(ht)
	} else {
		at = c(0.5, cutoff, 1)
		labels = c(0.5, paste0(cutoff, " (cutoff)"), 1)
		draw(ht, heatmap_legend_list = list(Legend(title = "Score", col_fun = score_col_fun, at = at, labels = labels)))
	}
	decorate_heatmap_body("Similarity", {
		grid.rect(gp = gpar(fill = NA, col = "#404040"))
		cl = factor(cl, levels = unique(cl[od]))
		tbcl = table(cl)
		ncl = length(cl)
		x = cumsum(c(0, tbcl))/ncl
		grid.segments(x, 0, x, 1, default.units = "npc", gp = gpar(col = "#404040"))
		grid.segments(0, 1 - x, 1, 1 - x, default.units = "npc", gp = gpar(col = "#404040"))
	})
}

#' Cluster functional terms by recursively binary cutting the similarity matrix
#'
#' @param mat A similarity matrix.
#' @param value_fun A function that calculates the scores for the four submatrices on a node.
#' @param partition_fun A function to split each node into two groups. Pre-defined functions
#'                in this package are [`partition_by_kmeanspp()`], [`partition_by_pam()`]  and [`partition_by_hclust()`].
#' @param cutoff The cutoff for splitting the dendrogram.
#' @param try_all_partition_fun Different `partition_fun` may give different clusterings. If the vaule
#'      of `try_all_partition_fun` is set to `TRUE`, the similarity matrix is clustered by three
#'      partitioning method: `partition_by_pam()`, `partition_by_kmeanspp()` and `partition_by_hclust()`.
#'      The clustering with the highest difference score is finally selected as the final clustering.
#' @param partial Whether to generate the complete clustering or the clustering stops when sub-matrices
#'     cannot be split anymore.
#'
#' @returns
#' `binary_cut()` returns a vector of numeric cluster labels. 
#' 
#' @rdname binary_cut
#' @export
#'
#' @examples
#' mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
#'     package = "simplifyEnrichment"))
#' binary_cut(mat)
binary_cut = function(mat, value_fun = area_above_ecdf, partition_fun = partition_by_hclust,
	cutoff = 0.85, try_all_partition_fun = TRUE, partial = nrow(mat) > 1500) {

	if(try_all_partition_fun) {
		clt = list(
			by_pam = binary_cut(mat, value_fun = value_fun, partition_fun = partition_by_pam,
				cutoff = cutoff, try_all_partition_fun = FALSE, partial = partial),
			by_kmeanspp = binary_cut(mat, value_fun = value_fun, partition_fun = partition_by_kmeanspp,
				cutoff = cutoff, try_all_partition_fun = FALSE, partial = partial),
			by_hclust = binary_cut(mat, value_fun = value_fun, partition_fun = partition_by_hclust,
				cutoff = cutoff, try_all_partition_fun = FALSE, partial = partial)
		)
		i = which.max(sapply(clt, function(cl) difference_score(mat, cl)))

		# qqcat("@{names(clt)[i]} gives the highest difference score\n")
		if(length(i) == 0) i = 1
		return(clt[[i]])
	}

	if(partial) {
		cl = cluster_mat2(mat, value_fun = value_fun, partition_fun = partition_fun, cutoff = cutoff)
	} else {
		dend = cluster_mat(mat, value_fun = value_fun, partition_fun = partition_fun, cutoff = cutoff)
		cl = cut_dend(dend, cutoff)
	}
	return(as.numeric(as.vector(unname(cl))))
}

#' Select the cutoff for binary cut
#'
#' @param mat A similarity matrix.
#' @param cutoff A list of cutoffs to test. Note the range of the cutoff values should be inside `[0.5, 1]`.
#' @param verbose Whether to print messages.
#' @param ... Pass to [`binary_cut()`].
#'
#' @details
#' Binary cut is applied to each cutoff and the clustering results are evaluated by following metrics:
#'
#' - difference score, calculated by [`difference_score()`].
#' - number of clusters.
#' - block mean, which is the mean similarity in the blocks in the diagonal of the heatmap.
#' @export
#' @examples
#' \donttest{
#' mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
#'     package = "simplifyEnrichment"))
#' select_cutoff(mat)
#' }
select_cutoff = function(mat, cutoff = seq(0.6, 0.98, by = 0.01), verbose = se_opt$verbose, ...) {

	cutoff = cutoff[cutoff >= 0.5 & cutoff <= 1]
	if(length(cutoff) == 0) {
		stop("`cutoff` should be within [0.5, 1].")
	}

	s1 = s2 = s3 = s4 = NULL
	for(i in seq_along(cutoff)) {
		if(verbose) message(qq("@{i}/@{length(cutoff)}, cutoff = @{cutoff[i]}..."))
		cl = binary_cut(mat, cutoff = cutoff[i], ...)
		s1[i] = difference_score(mat, cl)
		tb = table(cl)
		s2[i] = length(tb)
		s3[i] = sum(tb >= 5)
		s4[i] = block_mean(mat, cl)
	}

	check_pkg("cowplot", bioc = FALSE)
	check_pkg("ggplot2", bioc = FALSE)

	suppressWarnings(
		p1 <- ggplot2::ggplot(data = NULL, ggplot2::aes(x = cutoff, y = s1)) +
		ggplot2::geom_point() + ggplot2::ylab("Difference score") +
		ggplot2::theme(axis.title.x = ggplot2::element_blank(), axis.text.x = ggplot2::element_blank())
	)

	df1 = data.frame(cutoff, s2); colnames(df1) = c("method", "value")
	df2 = data.frame(cutoff, s3); colnames(df2) = c("method", "value")
	df1$type = "All sizes"
	df2$type = "Size >= 5"
	df = rbind(df1, df2)
	suppressWarnings(
		p2 <- ggplot2::ggplot(df, ggplot2::aes(x = df$method, y = df$value, col = df$type, fill = df$type)) +
		ggplot2::geom_point() + ggplot2::ylab("Number of clusters") + ggplot2::labs(col = "Type", fill = "Type") +
		ggplot2::theme(axis.title.x = ggplot2::element_blank(), axis.text.x = ggplot2::element_blank())
	)

	suppressWarnings(
		p3 <- ggplot2::ggplot(data = NULL, ggplot2::aes(x = cutoff, y = s4)) +
		ggplot2::geom_point() + ggplot2::ylab("Block mean") + ggplot2::xlab("Cutoff") +
		ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 45, hjust = 1))
	)

	suppressWarnings(print(cowplot::plot_grid(p1, p2, p3, nrow = 3, align = "v", axis = "lr", rel_heights = c(1, 1, 1.3))))
}

##### old implementation
cluster_mat_old = function(mat, value_fun = area_above_ecdf, partition_fun = partition_by_pam,
	cutoff = 0.85) {

	env = new.env()
	env$value_fun = value_fun
	env$partition_fun = partition_fun

	.cluster_mat_old(mat, dist_mat = dist(mat), .env = env)
	dend = env$dend
	dend = rev(dend)

	max_d = simplifyEnrichment:::dend_max_depth(dend)
	dend = dendrapply(dend, function(d) {
		attr(d, "height") = max_d - attr(d, "height")
		d
	})

	# to correctly assign midpoint for each node
	dend2 = as.dendrogram(as.hclust(dend))

	dend = edit_node(dend, function(d, index) {
		if(is.null(index)) {  # top node
			if(!is.leaf(d)) {
				attr(d, "midpoint") = attr(dend2, "midpoint")
			}
		} else {
			if(!is.leaf(d)) {
				attr(d, "midpoint") = attr(dend2[[index]], "midpoint")
			}
		}
		return(d)
	})

	## bottom-up
	assign_score2 = function(d) {
		if(is.leaf(d)) {
			attr(d, "score2") = 0.5
			return(d)
		}
		# check the two child node
		if(is.null(attr(d[[1]], "score2"))) {
			d[[1]] = assign_score2(d[[1]])
		}
		if(is.null(attr(d[[2]], "score2"))) {
			d[[2]] = assign_score2(d[[2]])
		}

		s2 = max(attr(d[[1]], "score2"), attr(d[[2]], "score2"))
		# the node is assigned with its child nodes' score only if
		# 1. the size of the two children should not be too extremely different
		# 2. the score should not be too smaller than its child nodes' 
		s = attr(d, "score")
		if( min(nobs(d[[1]]), nobs(d[[2]]))/nobs(d) < 0.1 ) {
			attr(d, "score2")  = s
		} else if(s > cutoff*0.8 && s < s2) {
			attr(d, "score2") = s2
		} else {
			attr(d, "score2")  = s
		}
		return(d)
	}
	dend = assign_score2(dend)

	hash = digest::digest(list(mat, value_fun, partition_fun, cutoff))
	# dend_env$dend = dend
	# dend_env$hash = hash

	return(dend)
}

.cluster_mat_old = function(mat, dist_mat = dist(mat), .env, index = seq_len(nrow(mat)), 
	depth = 0, dend_index = NULL) {
	nr = nrow(mat)

	if(nr == 1) {
		.env$dend[[dend_index]] = index
		attributes(.env$dend[[dend_index]]) = list(
			members = 1,
			label = "",
			leaf = TRUE,
			height = depth,
			score = 0.5,
			index = dend_index,
			class = "dendrogram"
		)
		return(NULL)
	}

	if(nrow(mat) == 2) {
		cl = c(1, 2)
	} else {
		oe = try(suppressWarnings(cl <- .env$partition_fun(mat)), silent = TRUE)
		if(inherits(oe, "try-error")) {
			cl = rep(2, nr)
			cl[seq_len(ceiling(nr/2))] = 1
		}
	}

	l1 = cl == 1
	l2 = cl == 2
	if(mean(mat[l1, l1]) > mean(mat[l2, l2])) {
		l3 = l1
		l1 = l2
		l2 = l3
	}
	m11 = mat[l1, l1, drop = FALSE]
	if(nrow(m11) == 1) {
		x11 = 1
		x12 = .env$value_fun(mat[l1, l2])
		x21 = .env$value_fun(mat[l2, l1])
	} else {
		m11 = m11[ lower.tri(m11) | upper.tri(m11)]
		x11 = .env$value_fun(m11)
		x12 = .env$value_fun(mat[l1, l2])
		x21 = .env$value_fun(mat[l2, l1])
	}
	m22 = mat[l2, l2, drop = FALSE]
	if(nrow(m22) == 1) {
		x22 = 1
	} else {
		m22 = m22[ lower.tri(m22) | upper.tri(m22)]
		x22 = .env$value_fun(m22)
	}
	
	s = (x11 + x22)/(x11 + x12 + x21 + x22)
	if(is.na(s)) s = 1

	if(is.null(dend_index)) {
		.env$dend = list()
		attributes(.env$dend) = list(
			members = nrow(mat),
			height = depth,
			score = s,
			index = NULL,
			class = "dendrogram"
		)
	} else {
		.env$dend[[dend_index]] = list()
		attributes(.env$dend[[dend_index]]) = list(
			members = nrow(mat),
			height = depth,
			score = s,
			index = dend_index,
			class = "dendrogram"
		)
	}

	.cluster_mat_old(mat[l1, l1, drop = FALSE], as.dist(as.matrix(dist_mat)[l1, l1, drop = FALSE]), 
		.env, index = index[l1], depth = depth + 1, dend_index = c(dend_index, 1))
	.cluster_mat_old(mat[l2, l2, drop = FALSE], as.dist(as.matrix(dist_mat)[l2, l2, drop = FALSE]), 
		.env, index = index[l2], depth = depth + 1, dend_index = c(dend_index, 2))
}

### test

mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", package = "simplifyEnrichment"))

dend1 = cluster_mat_old(mat)

dend1 = dendrapply(dend1, function(d) {
	attr(d, "index") = NULL
	d
})
dend2 = simplifyEnrichment:::cluster_mat(mat)


context("test cluster_mat")

test_that("test cluster_mat", {
	expect_equal(attributes(dend1), attributes(dend2))
	expect_equal(attributes(dend1[[1]]), attributes(dend2[[1]]))
	expect_equal(attributes(dend1[[c(1, 1)]]), attributes(dend2[[c(1, 1)]]))

	expect_equal(dend1, dend2)
})

#' Calculate word frequency
#'
#' @param term A vector of description texts.
#' @param exclude_words The words that should be excluded.
#' @param stop_words The stop words that should be be removed.
#' @param min_word_length Minimum length of the word to be counted.
#' @param tokenizer The tokenizer function, one of the values accepted by ``tm::termFreq``.
#' @param transform_case The function normalizing lettercase of the words.
#' @param remove_numbers Whether to remove numbers.
#' @param remove_punctuation Whether to remove punctuation.
#' @param custom_transformer Custom function that transforms words.
#' @param stemming Whether to only keep the roots of inflected words.
#' @param dictionary A vector of words to be counted (if given all other words will be excluded).
#'
#' @details
#' The text preprocessing followings the instruction from \url{http://www.sthda.com/english/wiki/word-cloud-generator-in-r-one-killer-function-to-do-everything-you-need}.
#'
#' @return
#' A data frame with words and frequencies.
#' @export
#' @examples
#' gm = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", package = "simplifyEnrichment"))
#' go_id = rownames(gm)
#' go_term = AnnotationDbi::select(GO.db::GO.db, keys = go_id, columns = "TERM")$TERM
#' count_words(go_term) |> head()
count_words = function(term,
	exclude_words = NULL, stop_words = stopwords(),
	min_word_length = 1, tokenizer = 'words', transform_case = tolower,
	remove_numbers = TRUE, remove_punctuation = TRUE, custom_transformer = NULL,
	stemming = FALSE, dictionary = NULL) {
	
	# http://www.sthda.com/english/wiki/word-cloud-generator-in-r-one-killer-function-to-do-everything-you-need

	# Load the text as a corpus
	suppressWarnings({
		docs = VCorpus(VectorSource(term))
		# Convert the text to lower case
		docs = tm_map(docs, content_transformer(transform_case))
		if (remove_numbers) {
			# Remove numbers
			docs = tm_map(docs, removeNumbers)
		}
		# Remove stopwords for the language
		docs = tm_map(docs, removeWords, stop_words)
		if (remove_punctuation) {
			# Remove punctuations
			docs = tm_map(docs, removePunctuation)
		}
		# Eliminate extra white spaces
		docs = tm_map(docs, stripWhitespace)
		# Remove your own stopwords
		docs = tm_map(docs, removeWords, exclude_words)
		# Apply any user-provided transformer
		if (!is.null(custom_transformer)) {
			docs = tm_map(docs, content_transformer(custom_transformer))
		}

		# Create term-document matrix
		tdm = TermDocumentMatrix(
			docs,
			control = list(
				wordLengths = c(min_word_length, Inf),
				tokenize = tokenizer,
				stemming = stemming,
				dictionary = dictionary,
				# letter case transformation is handled earlier (above), let's not overwrite the results
				tolower = FALSE
			)
		)
	})
	v = sort(slam::row_sums(tdm), decreasing = TRUE)
	d = data.frame(word = names(v), freq = v, stringsAsFactors = FALSE)
	d
}


#' A simple grob for the word cloud
#'
#' @param text A vector of words.
#' @param fontsize The corresponding font size. With the frequency of the words known, `scale_fontsize` can be used to linearly interpolate frequencies to font sizes.
#' @param line_space Space between lines. The value can be a `grid::unit` object or a numeric scalar which is measured in mm.
#' @param word_space Space between words. The value can be a `grid::unit` object or a numeric scalar which is measured in mm.
#' @param max_width The maximal width of the viewport to put the word cloud. The value can be a `grid::unit` object or a numeric scalar which is measured in mm.
#'        Note this might be larger than the final width of the returned grob object.
#' @param col Colors for the words. The value can be a vector, in numeric or character, which should have the same
#'      length as ``text``. Or it is a self-defined function that takes the font size vector as 
#'      the only argument. The function should return a color vector. See Examples.
#' @param add_new_line Whether to add new line after every word? If ``TRUE``, each word will be in a separated line.
#' @param test Internally used. It basically adds borders to the words and the viewport.
#'
#' @return
#' A `grid::grob` object. The width and height of the grob can be get by `grid::grobWidth` and `grid::grobHeight`.
#' @export
#' @examples
#' # very old R versions do not have strrep() function
#' if(!exists("strrep")) {
#'     strrep = function(x, i) paste(rep(x, i), collapse = "")
#' }
#' words = sapply(1:30, function(x) strrep(sample(letters, 1), sample(3:10, 1)))
#' require(grid)
#' gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
#'     max_width = 100)
#' grid.newpage(); grid.draw(gb)
#'
#' # color as a single scalar
#' gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
#'     max_width = 100, col = 1)
#' grid.newpage(); grid.draw(gb)
#'
#' # color as a vector
#' gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
#'     max_width = 100, col = 1:30)
#' grid.newpage(); grid.draw(gb)
#'
#' # color as a function
#' require(circlize)
#' col_fun = colorRamp2(c(5, 17, 30), c("blue", "black", "red"))
#' gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
#'     max_width = 100, col = function(fs) col_fun(fs))
#' grid.newpage(); grid.draw(gb)
#'
word_cloud_grob = function(text, fontsize, 
	line_space = unit(4, "pt"), word_space = unit(4, "pt"), max_width = unit(80, "mm"), 
	col = function(fs) circlize::rand_color(length(fs), luminosity = "dark"),
	add_new_line = FALSE, test = FALSE) { # width in mm

	if(length(text) != length(fontsize)) {
		stop_wrap("`text` and `fontsize` should the same length.")
	}

	n = length(text)

	if(is.character(col) || is.numeric(col)) {
		if(length(col) == 1) col = rep(col, n)
	} else if(is.function(col)) {
		col = col(fontsize)
	} else {
		stop_wrap("`col` can only be a function or a character vector.")
	}
	
	od = order(fontsize, decreasing = TRUE)
	text = text[od]
	fontsize = fontsize[od]
	col = col[od]

	# if(Sys.info()["sysname"] == "Darwin" && dev.interactive()) {
	# 	ComplexHeatmap:::dev.null()
	# 	on.exit(ComplexHeatmap:::dev.off2())
	# }

	text_gb_lt = lapply(seq_len(n), function(i) textGrob(text[i], gp = gpar(fontsize = fontsize[i])))
	text_width = vapply(text_gb_lt, function(gb) convertWidth(grobWidth(gb), "mm", valueOnly = TRUE), 0)
	text_height = vapply(text_gb_lt, function(gb) convertHeight(grobHeight(gb), "mm", valueOnly = TRUE), 0)

	if(is.unit(line_space)) line_space = convertHeight(line_space, "mm", valueOnly = TRUE)
	if(is.unit(word_space)) word_space = convertWidth(word_space, "mm", valueOnly = TRUE)

	x = numeric(n)
	y = numeric(n)
	current_line_height = 0
	current_line_width = 0

	# the first text
	current_line_height = text_height[1]
	current_line_width = text_width[1]
	x[1] = 0
	y[1] = 0

	w = text_width[1]
	h = text_height[1]

	if(is.unit(max_width)) {
		max_width = convertWidth(max_width, "mm", valueOnly = TRUE)
	} 

	for(i in seq_len(n)[-1]) {
		# the next text can be put on the same line
		if(current_line_width + text_width[i] <= max_width && !add_new_line) {
			x[i] = current_line_width + word_space
			y[i] = y[i-1] # same as previous one
			current_line_width = x[i] + text_width[i]
			w = max(w, current_line_width)
			h = max(h, y[i] + text_height[i])
		} else { # the next text need to be put on the next line
			x[i] = 0
			y[i] = current_line_height + line_space
			current_line_width = text_width[i]
			current_line_height = y[i] + text_height[i]
			w = max(w, current_line_width)
			h = max(h, current_line_height)
		}
	}

	if(test) {
		gl = gList(
			rectGrob(),
			textGrob(text, x = x, y = y, gp = gpar(fontsize = fontsize, col = col), 
				default.units = "mm", just = c(0, 0)),
			rectGrob(x = x, y = y, width = text_width, height = text_height, default.units = "mm", just = c(0, 0))

		)
	} else {
		gl = gList(
			textGrob(text, x = x, y = y, gp = gpar(fontsize = fontsize, col = col), 
				default.units = "mm", just = c(0, 0))
		)
	}

	gb = gTree(children = gl, cl = "word_cloud", vp = viewport(width = unit(w, "mm"), height = unit(h, "mm")))
	return(gb)
}

#' @rdname word_cloud_grob
#'
#' @param x The ``word_cloud`` grob returned by `word_cloud_grob`.
#' @export
widthDetails.word_cloud = function(x) {
	x$vp$width
}

#' @rdname word_cloud_grob
#'
#' @export
heightDetails.word_cloud = function(x) {
	x$vp$height
}


#' Word cloud annotations
#'
#' @param align_to How to align the annotations to the heatmap. Similar as in `ComplexHeatmap::anno_link`, the value of ``align_to``
#'           can be a list of row indices or a categorical vector where each vector in the list corresponds to a word cloud. 
#'           If it is a categorical vector, rows with the same level correspond to a same word cloud. 
#'           If ``align_to`` is a categorical vector and ``term`` is a list, names of ``term`` should have overlap to the levels in ``align_to``.
#'           When ``align_to`` is set as a categorical vector, normally the same value is set to ``row_split`` in the main heatmap so that each row slice
#'           can correspond to a word cloud.
#' @param term The description text used for constructing the word clouds. The value should have the same format as ``align_to``. If ``align_to``
#'          is a list, ``term`` should also be a list. In this case, the length of vectors in ``term`` is not necessarily the same
#'          as in ``align_to``. E.g. ``length(term[[1]])`` is not necessarily equal to ``length(align_to[[1]]``. If ``align_to``
#'          is a categorical vector, ``term`` should also be a character vector with the same length as ``align_to``.
#'          To make it more genrall, when ``align_to`` is a list, ``term`` can also be a list of data frames where the first column contains 
#'          keywords and the second column contains numeric values that will be mapped to font sizes in the word clouds.
#' @param exclude_words The words excluced for construcing word cloud.
#' @param max_words Maximal number of words visualized in the word cloud.
#' @param word_cloud_grob_param A list of graphics parameters passed to `word_cloud_grob`.
#' @param fontsize_range The range of the font size. The value should be a numeric vector with length two.
#'       The font size interpolation is linear.
#' @param value_range The range of values to map to font sizes.
#' @param bg_gp Graphics parameters for controlling the background.
#' @param side Side of the annotation relative to the heatmap.
#' @param add_new_line Whether to add new line after every word? If ``TRUE``, each word will be in a separated line.
#' @param count_words_param A list of parameters passed to `count_words`.
#' @param ... Other parameters.
#' @param return_gbl Internally used.
#'
#' @details
#' The word cloud annotation is constructed by `ComplexHeatmap::anno_link`.
#'
#' If the annotation is failed to construct or no keyword is found, the function returns a `ComplexHeatmap::anno_empty` with 1px width.
#'
#' English stop words, punctuation and numbers are removed by default when counting words. As specific stop words might
#' coincide with gene or pathway names, and numbers in genes names might be meaningful it is recommended to adjust this
#' behaviour by passing appropriate arguments to the `count_words` function using ``count_words_param``.
#' @export
#' @import colorspace
#' @import methods
#' @examples
#' gm = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", package = "simplifyEnrichment"))
#' go_id = rownames(gm)
#' go_term = AnnotationDbi::select(GO.db::GO.db, keys = go_id, columns = "TERM")$TERM
#'
#' split = sample(letters[1:4], 100, replace = TRUE)
#' align_to = split(1:100, split)
#' term = lapply(letters[1:4], function(x) sample(go_term, sample(100:400, 1)))
#' names(term) = letters[1:4]
#'
#' require(ComplexHeatmap)
#' mat = matrix(rnorm(100*10), nrow = 100)
#' Heatmap(mat, cluster_rows = FALSE, row_split = split, 
#' 	right_annotation = rowAnnotation(foo = anno_word_cloud(align_to, term)))
#'
anno_word_cloud = function(align_to, term, exclude_words = NULL, max_words = 10,
	word_cloud_grob_param = list(), fontsize_range = c(4, 16), value_range = NULL,
	bg_gp = gpar(fill = "#DDDDDD", col = "#AAAAAA"), side = c("right", "left"),
	add_new_line = FALSE, count_words_param = list(), ..., return_gbl = FALSE) {

	if(is.atomic(align_to) && is.list(term)) {
		align_to = split(seq_along(align_to), align_to)

		cn = intersect(names(align_to), names(term))
		if(length(cn) == 0) {
			stop_wrap("names of `term` should have overlap to the `align_to`.")
		} else {
			align_to = align_to[cn]
			term = term[cn]
		}

	} else if(is.list(align_to)) {
		if(!is.list(term)) {
			stop_wrap("`term` should have the same format as `align_to`, which is a list of term descriptions. Note, e.g. `length(term[[1]])` are not necessarily equal to `length(align_to[[1]]`.")
		} else {
			if(length(align_to) != length(term)) {
				stop_wrap("`align_to` and `term` should be two list with the same length.")
			}
		}
		if(!is.null(names(align_to)) && !is.null(names(term))) {
			if(length(setdiff(names(align_to), names(term))) == 0) {
				term = term[names(align_to)]
			}
		}
	} else if(is.atomic(align_to)) {
		if(!is.atomic(term)) {
			stop_wrap("`term` should have the same format as `align_to`, which is a vector of term descriptions with the same length as `align_to`.")
		}
		term = split(term, align_to)
		align_to = split(seq_along(align_to), align_to)
	}

	flag = 0
	if(is.list(term)) {
		is_term_a_data_frame = sapply(term, is.data.frame)
		if(any(is_term_a_data_frame)) {
			if(!all(is_term_a_data_frame)) {
				stop_wrap("Elements in `term` should all be data.frames")
			}

			sapply(term, function(x) {
				if(ncol(x) < 2) {
					stop_wrap("Data frame in `term` should have more than one column.")
				}
				if(!any(sapply(x[, -1, drop = FALSE], is.numeric))) {
					stop_wrap("There should be a numeric column in the data frame.")
				}
			})
			flag = 1
		}
	}

	if(flag) {
		keywords = lapply(term, function(df) {
			if(nrow(df) > max_words) {
				df = df[order(df[, 2], decreasing = TRUE)[seq_len(max_words)], ]
			}
			df[!df[, 1] %in% exclude_words, , drop = FALSE]
		})
	} else {
		keywords = lapply(term, function(desc) {
			combined_count_params = c(list(term = desc, exclude_words = exclude_words), count_words_param)
			suppressMessages(suppressWarnings(df <- do.call(count_words, combined_count_params)))
			# df = df[df$freq > 1, , drop = FALSE]
			if(nrow(df) > max_words) {
				df = df[order(df$freq, decreasing = TRUE)[seq_len(max_words)], ]
			}
			df
		})
	}
	keywords = keywords[vapply(keywords, nrow, 0) > 0]

	align_to = align_to[names(keywords)]

	if(length(keywords) == 0) {
		return(anno_empty(border = FALSE, width = unit(1, "pt")))
	}

	if(length(word_cloud_grob_param)) {
		if(is.atomic(word_cloud_grob_param)) {
			stop_wrap("`word_cloud_grob_param` should be a named list.")
		}
	}

	all_keywords = unique(unlist(lapply(keywords, function(x) x[, 1])))
	all_keywords_col = circlize::rand_color(length(all_keywords), luminosity = "dark")
	i_try = 1
	while(1) {
		hsv = coords(as(hex2RGB(all_keywords_col), "HSV"))
		l = hsv[, 3] > 0.85 | (hsv[, 1] > 40 & hsv[, 1] < 65)
		if(!any(l)) break
		i_try = i_try + 1
		if(i_try > 50) break
		all_keywords_col[l] = circlize::rand_color(sum(l), luminosity = "dark")
	}
	all_keywords_col = structure(all_keywords_col, names = all_keywords)

	word_cloud_grob_param = word_cloud_grob_param[setdiff(names(word_cloud_grob_param), c("text", "fontsize"))]
	ComplexHeatmap:::dev.null()
	oe = try({
		gbl <- lapply(names(align_to), function(nm) {
			kw = rev(keywords[[nm]][, 1])
			freq = rev(keywords[[nm]][, 2])
			if(is.null(value_range)) {
				fontsize = scale_fontsize(freq, rg = c(1, max(10, freq)), fs = fontsize_range)
			} else {
				fontsize = scale_fontsize(freq, rg = value_range, fs = fontsize_range)
			}

			if(!"col" %in% names(word_cloud_grob_param)) {
				word_cloud_grob_param$col = function(fs) all_keywords_col[kw]
			}

			lt = c(list(text = kw, fontsize = fontsize, add_new_line = add_new_line), word_cloud_grob_param)
			do.call(word_cloud_grob, lt)
		})
		names(gbl) = names(align_to)
	
		margin = unit(8, "pt")
		gbl_h = lapply(gbl, function(x) convertHeight(grobHeight(x), "cm") + margin)
		gbl_h = do.call(unit.c, gbl_h)

		gbl_w = lapply(gbl, function(x) convertWidth(grobWidth(x), "cm"))
		gbl_w = do.call(unit.c, gbl_w)
		gbl_w = max(gbl_w) + margin

	}, silent = TRUE)
	ComplexHeatmap:::dev.off2()
	if(inherits(oe, "try-error")) {
		stop(oe)
	}

	if(return_gbl) {
		return(gbl)
	}

	if(is.null(bg_gp$fill)) bg_gp$fill = "#DDDDDD"
	if(is.null(bg_gp$col)) bg_gp$col = "#AAAAAA"
	if(is.null(bg_gp$lty)) bg_gp$lty = 1
	if(is.null(bg_gp$lwd)) bg_gp$lwd = 1

	side = match.arg(side)[1]

	panel_fun = function(index, nm) {
		pushViewport(viewport())
		grid.rect(gp = gpar(fill = bg_gp$fill, col = bg_gp$fill, lty = bg_gp$lty, lwd = bg_gp$lwd))
		if(side == "right") {
			grid.lines(c(0, 1, 1, 0), c(0, 0, 1, 1), gp = gpar(col = bg_gp$col, lty = bg_gp$lty, lwd = bg_gp$lwd), default.units = "npc")
		} else {
			grid.lines(c(1, 0, 0, 1), c(0, 0, 1, 1), gp = gpar(col = bg_gp$col, lty = bg_gp$lty, lwd = bg_gp$lwd), default.units = "npc")
		}
	    pushViewport(viewport(width = unit(1, "npc") - margin, height = unit(1, "npc") - margin))
	    gb = gbl[[nm]]
	    gb$vp$x = gb$vp$width*0.5
	    gb$vp$y = gb$vp$height*0.5
	    grid.draw(gb)
	    popViewport()
	    popViewport()
	}

	anno = anno_link(align_to = align_to, which = "row", panel_fun = panel_fun, 
    	size = gbl_h, gap = unit(2, "mm"), width = gbl_w + unit(5, "mm"),
    	link_gp = bg_gp, internal_line = FALSE, side = side, ...)
	anno
}

#' Word cloud annotations from GO
#'
#' @param align_to The same format as in `anno_word_cloud`.
#' @param go_id The value should be in the same format as ``align_to``. If ``go_id`` is a vector, it should have the
#'       same length as ``align_to``, and if ``go_id`` is a list, note, e.g. ``length(go_id[[1]])`` is not necessarily equal to ``length(align_to[[1]]``.
#'       If ``align_to`` is a categorical vector and ``go_id`` is a list, names of ``go_id`` should have overlap to the levels in ``align_to``.
#' @param min_stat Minimal value for ``stat`` for selecting keywords.
#' @param stat What type of value to map to font sizes of the keywords. There are two possible values. "pvalue": enrichment is applied to keywords and -log10(p-value)
#'       is used to map to font size; "count": simply word frequency of keywords.
#' @param term Alternatively the GO description can be set via the ``term`` argument. The same format as in `anno_word_cloud`.
#' @param exclude_words The words excluced for construcing word cloud. Some words are internally exclucded: ``c("via", "protein", "factor", "side", "type", "specific")``.
#' @param ... All other arguments passed to `anno_word_cloud`.
#' 
#' @export
#' @import slam
anno_word_cloud_from_GO = function(align_to, go_id, stat = c("pvalue", "count"), 
	min_stat = ifelse(stat == "count", 5, 0.05),
	term = NULL, exclude_words = NULL, ...) {

	if(is.null(term)) {
		if(is.atomic(align_to) && is.list(go_id)) {
			align_to = split(seq_along(align_to), align_to)

			cn = intersect(names(align_to), names(go_id))
			if(length(cn) == 0) {
				stop_wrap("names of `go_id` should have overlap to the `align_to`.")
			} else {
				align_to = align_to[cn]
				go_id = go_id[cn]
			}

		} else if(is.list(align_to)) {
			if(!is.list(go_id)) {
				stop_wrap("`go_id` should have the same format as `align_to`, which is a list of term descriptions. Note, e.g. `length(go_id[[1]])` are not necessarily equal to `length(align_to[[1]]`.")
			} else {
				if(length(align_to) != length(go_id)) {
					stop_wrap("`align_to` and `go_id` should be two list with the same length.")
				}
			}
			if(!is.null(names(align_to)) && !is.null(names(go_id))) {
				if(length(setdiff(names(align_to), names(go_id))) == 0) {
					go_id = go_id[names(align_to)]
				}
			}
		} else if(is.atomic(align_to)) {
			if(!is.atomic(go_id)) {
				stop_wrap("`go_id` should have the same format as `align_to`, which is a vector of GO IDs with the same length as `align_to`.")
			}
			go_id = split(go_id, align_to)
			align_to = split(seq_along(align_to), align_to)
		}

		stat = match.arg(stat)[1]
		if(is.null(env$tdm_GO)) {
			# env$tdm_GO = readRDS("~/project/development/simplifyEnrichment/inst/extdata/tdm_GO.rds")
			env$tdm_GO = readRDS(system.file("extdata", "tdm_GO.rds", package = "simplifyEnrichment"))
		}

		if(stat == "pvalue") message(qq("Perform keywords enrichment for @{length(go_id)} GO lists..."))
		term = lapply(go_id, function(x) {
			if(is_GO_id(x[1])) {
				
				if(stat == "count") {
					v = row_sums(env$tdm_GO[, intersect(x, colnames(env$tdm_GO))])
					v = v[v >= min_stat]
					data.frame(names(v), v)
				} else if(stat == "pvalue") {
					df = keyword_enrichment(x, env$tdm_GO)
					df = df[df$p <= min_stat, , drop = FALSE]
					data.frame(df[, 1], -log10(df$p))
				}
			} else {
				stop_wrap("Cannot automatically retrieve the term names by the input ID, please set values for `term` argument manually.")
			}
			
		})
	} 

	anno_word_cloud(align_to, term, exclude_words = c(exclude_words, GO_EXCLUDE_WORDS), ...)
	
}

next_k = local({
	k = 0
	function(reset = FALSE) {
		if(reset) {
			k <<- 0
		} else {
			k <<- k + 1
		}
		k
	}
})

#' Apply functions on every node in a dendrogram
#' 
#' @rdname dend
#'
#' @param dend A `dendrogram` object.
#' @param fun A self-defined function.
#'
#' @details
#' `dend_node_apply()` returns a vector or a list as the same length as the number of nodes in the dendrogram.
#'
#' The self-defined function can have one single argument which is the sub-dendrogram at a certain node.
#' E.g. to get the number of members at every node:
#'
#' ```
#' dend_node_apply(dend, function(d) attr(d, "members"))
#' ```
#' 
#' The self-defined function can have a second argument, which is the index of current sub-dendrogram in 
#' the complete dendrogram. E.g. `dend[[1]]` is the first child node of the complete dendrogram and
#' `dend[[c(1, 2)]]` is the second child node of `dend[[1]]`, et al. This makes that at a certain node,
#' it is possible to get information of its child nodes and parent nodes. 
#'
#' ```
#' dend_node_apply(dend, function(d, index) {
#'     dend[[c(index, 1)]] # is the first child node of d, or simply d[[1]]
#'     dend[[index[-length(index)]]] # is the parent node of d
#'     ...
#' })
#' ```
#'
#' Note for the top node, the value of `index` is `NULL`.
#'
#' @return
#' `dend_node_apply()` returns a vector or a list, depends on whether `fun` returns a scalar or more complex values.
#' @export
#' @examples
#' mat = matrix(rnorm(100), 10)
#' dend = as.dendrogram(hclust(dist(mat)))
#' # number of members on every node
#' dend_node_apply(dend, function(d) attr(d, "members"))
#' # the depth on every node
#' dend_node_apply(dend, function(d, index) length(index))
dend_node_apply = function(dend, fun) {

	next_k(reset = TRUE)

	assign_to = function(env, k, v) {
		n = length(env$var)
		if(n == 0) {
			env$var = list()
		}
		env$var[[k]] = v
	}


	if(length(as.list(formals(fun))) == 1) {
		fun2 = fun
		fun = function(d, index) fun2(d)
	}

	env = new.env()
	.do = function(dend, fun, index) {

		if(is.null(index)) {
			if(is.leaf(dend)) {
				assign_to(env, next_k(), fun(dend, index))
				return(NULL)
			} else {
				assign_to(env, next_k(), fun(dend, index))
			}
		} else {
			assign_to(env, next_k(), fun(dend[[index]], index))

			if(is.leaf(dend[[index]])) {
				return(NULL)
			}
		}

		if(is.null(index)) {
			n = length(dend)
		
		} else {
			n = length(dend[[index]])
		}
		for(i in seq_len(n)) {
			.do(dend, fun, c(index, i))
		}
	}

	.do(dend, fun, NULL)

	var = env$var
	if(all(vapply(var, is.atomic, TRUE))) {
		if(all(vapply(var, length, 0) == 1)) {
			var = unlist(var)
		}
	}

	return(var)
}


#' @rdname dend
#'
#' @details
#' In `edit_node()`, if `fun` only has one argument, it is basically the same as [`stats::dendrapply()`],
#' but it can have a second argument which is the index of the node in the dendrogram,
#' which makes it possible to get information of child nodes and parent nodes for
#' a specific node.
#'
#' As an example, we first assign random values to every node in the dendrogram:
#'
#' ```
#' mat = matrix(rnorm(100), 10)
#' dend = as.dendrogram(hclust(dist(mat)))
#' dend = edit_node(dend, function(d) {attr(d, 'score') = runif(1); d})
#' ````
#'
#' Then for every node, we take the maximal absolute difference to all its child nodes
#' and parent node as the attribute `abs_diff`.
#'
#' ```
#' dend = edit_node(dend, function(d, index) {
#'     n = length(index)
#'     s = attr(d, "score")
#'     if(is.null(index)) {  # d is the top node
#'         s_children = sapply(d, function(x) attr(x, "score"))
#'         s_parent = NULL
#'     } else if(is.leaf(d)) { # d is the leaf
#'         s_children = NULL
#'         s_parent = attr(dend[[index[-n]]], "score")
#'     } else {
#'         s_children = sapply(d, function(x) attr(x, "score"))
#'         s_parent = attr(dend[[index[-n]]], "score")
#'     }
#'     abs_diff = max(abs(s - c(s_children, s_parent)))
#'     attr(d, "abs_diff") = abs_diff
#'     return(d)
#' })
#' ```
#'
#' @return
#' `edit_node()` returns a `dendrogram` object.
edit_node = function(dend, fun = function(d, index) d) {

	# breadth first

	env = new.env()
	env$dend = dend

	if(length(as.list(formals(fun))) == 1) {
		fun2 = fun
		fun = function(d, index) fun2(d)
	}

	traverse_dend = function(env, index = NULL) {
		# index is null means it is the top node
		if(is.null(index)) {
			d = env$dend
			if(is.leaf(d)) {
				env$dend = fun(d, NULL)
				return(NULL)
			} else {
				env$dend = fun(d, NULL)

				for(i in seq_along(d)) {
					traverse_dend(env, i)
				}
			}
		} else {
			d = env$dend[[index]]
			if(is.leaf(d)) {
				env$dend[[index]] = fun(d, index)
				return(NULL)
			} else {
				env$dend[[index]] = fun(d, index)
				for(i in seq_along(d)) {
					traverse_dend(env, c(index, i))
				}
			}
		}
	}

	traverse_dend(env)
	return(env$dend)
}

context("test dend_utils")

dend = as.dendrogram(hclust(dist(1:5)))
test_that("test dend_node_apply()", {
    h = dend_node_apply(dend, function(d, index) {
        h = attr(d, "height")
        if(is.null(index)) {
            names(h) = "top"
        } else {
            names(h) = paste(index, collapse = "")
        }
        h
    })

    expect_that(h[["top"]], equals(4))
    expect_that(h[["1"]], equals(1))
    expect_that(h[["2"]], equals(2))
   
})


test_that("test edit_node()", {
    dend2 = edit_node(dend, function(d, index) {
        attr(d, "index") = index
        d
    })

    expect_that(attr(dend2[[c(1, 2)]], "index"), equals(c(1, 2)))
})

#' Global parameters
#'
#' @param ... Arguments for the parameters, see "details" section.
#' @param RESET Whether to reset to default values.
#' @param READ.ONLY Please ignore.
#' @param LOCAL Please ignore.
#' @param ADD Please ignore.
#' 
#' @details
#' There are the following global options:
#'
#' - `verobse`: Whether to print messages.
#' 
#' @return A `GlobalOptionsFun` object.
#' @export
#' @import GlobalOptions
se_opt = setGlobalOptions(
	verbose = TRUE
)

#' Difference score
#'
#' @param mat The similarity matrix.
#' @param cl Cluster labels.
#'
#' @details
#' This function measures the different between the similarity values for the terms
#' that belong to the same clusters and in different clusters. The difference score
#' is the Kolmogorov-Smirnov statistic between the two distributions.
#'
#' @return
#' A numeric scalar.
#' @export
#' @examples
#' mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", 
#'     package = "simplifyEnrichment"))
#' cl = binary_cut(mat)
#' difference_score(mat, cl)
difference_score = function(mat, cl) {
	n = nrow(mat)
	l_block = matrix(FALSE, nrow = nrow(mat), ncol = ncol(mat))

	if(length(unique(cl)) == 1) {
		return(NA)
	}

	for(le in unique(cl)) {
		l = cl == le
		l_block[l, l] = TRUE
	}
	l_block2 = l_block
	l_block2[upper.tri(mat, diag = TRUE)] = FALSE
	x1 = mat[l_block2]

	l_block2 = !l_block
	l_block2[upper.tri(mat, diag = TRUE)] = FALSE
	x2 = mat[l_block2]

	if(length(x1) < 1) return(NA)
	if(length(x2) < 1) return(NA)

	ecdf1 = ecdf(x1)
	ecdf2 = ecdf(x2)

	p = seq(0, 1, length = 1000)
	max(abs(ecdf2(p) - ecdf1(p)))
}

block_mean = function(mat, cl) {
	n = nrow(mat)
	l_block = matrix(FALSE, nrow = nrow(mat), ncol = ncol(mat))

	for(le in unique(cl)) {
		l = cl == le
		l_block[l, l] = TRUE
	}
	l_block2 = l_block
	l_block2[upper.tri(mat, diag = TRUE)] = FALSE
	x1 = mat[l_block2]
	mean(x1)
}

other_mean = function(mat, cl) {
	n = nrow(mat)
	l_block = matrix(FALSE, nrow = nrow(mat), ncol = ncol(mat))

	for(le in unique(cl)) {
		l = cl == le
		l_block[l, l] = TRUE
	}

	l_block2 = !l_block
	l_block2[upper.tri(mat, diag = TRUE)] = FALSE
	x2 = mat[l_block2]
	mean(x2)
}


 # sapply(clt,function(cl)modularity(g, membership = cl, weights = get.edge.attribute(g, "weight")))

#' Simplify Gene Ontology (GO) enrichment results
#'
#' @param mat A GO similarity matrix. You can also provide a vector of GO IDs to this argument.
#' @param method Method for clustering the matrix. See [`cluster_terms()`].
#' @param control A list of parameters for controlling the clustering method, passed to [`cluster_terms()`].
#' @param plot Whether to make the heatmap.
#' @param column_title Column title for the heatmap.
#' @param verbose Whether to print messages.
#' @param ht_list A list of additional heatmaps added to the left of the similarity heatmap.
#' @param ... Arguments passed to [`ht_clusters()`].
#'
#' @details
#' This is basically a wrapper function that it first runs [`cluster_terms()`] to cluster
#' GO terms and then runs [`ht_clusters()`] to visualize the clustering.
#'
#' The arguments in `simplifyGO()` passed to `ht_clusters()` are:
#'
#' - `draw_word_cloud`: Whether to draw the word clouds.
#' - `min_term`: Minimal number of GO terms in a cluster. All the clusters
#'     with size less than `min_term` are all merged into one single cluster in the heatmap.
#' - `order_by_size`: Whether to reorder GO clusters by their sizes. The cluster
#'      that is merged from small clusters (size < `min_term`) is always put to the bottom of the heatmap.
#' - `stat`: What values of keywords are used to map to font sizes in the word clouds.
#' - `exclude_words`: Words that are excluded in the word cloud.
#' - `max_words`: Maximal number of words visualized in the word cloud.
#' - `word_cloud_grob_param`: A list of graphic parameters passed to [`word_cloud_grob()`].
#' - `fontsize_range` The range of the font size. The value should be a numeric vector with length two.
#'       The minimal font size is mapped to word frequency value of 1 and the maximal font size is mapped
#'       to the maximal word frequency. The font size interlopation is linear.
#' - `bg_gp`: Graphic parameters for controlling the background of word cloud annotations.
#'
#' @return
#' A data frame with two columns: GO IDs and cluster labels.
#' @export
#' @examples
#' \donttest{
#' set.seed(123)
#' go_id = random_GO(500)
#' mat = GO_similarity(go_id)
#' df = simplifyGO(mat, word_cloud_grob_param = list(max_width = 80))
#' head(df)
#' }
simplifyGO = function(mat, method = "binary_cut", control = list(), 
	plot = TRUE, verbose = TRUE, 
	column_title = qq("@{nrow(mat)} GO terms clustered by '@{method}'"),
	ht_list = NULL, ...) {

	if(is.atomic(mat) && !is.matrix(mat)) {
		go_id = mat
		if(!all(grepl("^GO:\\d+$", go_id))) {
			stop_wrap("If you specify a vector, it should contain all valid GO IDs.")
		}

		mat = GO_similarity(go_id)
	}
	
	cl = do.call(cluster_terms, list(mat = mat, method = method, verbose = verbose, control = control))
	go_id = rownames(mat)
	if(is.null(go_id)) {
		go_id = colnames(mat)
	}

	if(!all(grepl("^GO:\\d+$", go_id))) {
		stop_wrap("Please ensure GO IDs are the row names of the similarity matrix and should be matched to '^GO:\\\\d+$'.")
	}

	if(plot) ht_clusters(mat, cl, column_title = column_title, ht_list = ht_list, ...)

	return(invisible(data.frame(id = go_id, cluster = cl, stringsAsFactors = FALSE)))
}


#' @export
#' @rdname simplifyGO
simplifyEnrichment = function(...) {
	message("From version 2.0.0, `simplifyEnrichment()` is identical to `simplifyGO()`.")
	simplifyGO(...)
}

#' Perform simplifyGO analysis with multiple lists of GO IDs
#'
#' @param lt A data frame, a list of numeric vectors (e.g. adjusted p-values) where each numeric vector has GO IDs as names, or a list of GO IDs.
#' @param go_id_column Column index of GO ID if `lt` contains a list of data frames.
#' @param padj_column Column index of adjusted p-values if `lt` contains a list of data frames.
#' @param padj_cutoff Cut off for adjusted p-values.
#' @param filter A self-defined function for filtering GO IDs. By default it requires GO IDs should be significant in at least one list.
#' @param default The default value for the adjusted p-values. See **Details**.
#' @param ont Pass to [`GO_similarity()`].
#' @param db Pass to [`GO_similarity()`].
#' @param measure Pass to [`GO_similarity()`].
#' @param heatmap_param Parameters for controlling the heatmap, see **Details**.
#' @param show_barplot Whether draw barplots which shows numbers of significant GO terms in clusters.
#' @param method Pass to [`simplifyGO()`].
#' @param control Pass to [`simplifyGO()`].
#' @param min_term Pass to [`simplifyGO()`].
#' @param verbose Pass to [`simplifyGO()`].
#' @param column_title Pass to [`simplifyGO()`].
#' @param ... Pass to [`simplifyGO()`].
#'
#' @details
#' The input data can have three types of formats:
#'
#' - A list of numeric vectors of adjusted p-values where each vector has the GO IDs as names.
#' - A data frame. The column of the GO IDs can be specified with `go_id_column` argument and the column of the adjusted p-values can be
#'      specified with `padj_column` argument. If these columns are not specified, they are automatically identified. The GO ID column
#'      is found by checking whether a column contains all GO IDs. The adjusted p-value column is found by comparing the column names of the 
#'      data frame to see whether it might be a column for adjusted p-values. These two columns are used to construct a numeric vector
#'      with GO IDs as names.
#' - A list of character vectors of GO IDs. In this case, each character vector is changed to a numeric vector where
#'   all values take 1 and the original GO IDs are used as names of the vector.
#'
#' Now let's assume there are `n` GO lists, we first construct a global matrix where columns correspond to the `n` GO lists and rows correspond
#' to the "union" of all GO IDs in the lists. The value for the ith GO ID and in the jth list are taken from the corresponding numeric vector
#' in `lt`. If the jth vector in `lt` does not contain the ith GO ID, the value defined by `default` argument is taken there (e.g. in most cases the numeric
#' values are adjusted p-values, `default` is set to 1). Let's call this matrix as `M0`.
#'
#' Next step is to filter `M0` so that we only take a subset of GO IDs of interest. We define a proper function via argument `filter` to remove
#' GO IDs that are not important for the analysis. Functions for `filter` is applied to every row in `M0` and `filter` function needs
#' to return a logical value to decide whether to remove the current GO ID. For example, if the values in `lt` are adjusted p-values, the `filter` function
#' can be set as `function(x) any(x < padj_cutoff)` so that the GO ID is kept as long as it is signfiicant in at least one list. After the filter, let's call
#' the filtered matrix `M1`.
#'
#' GO IDs in `M1` (row names of `M1`) are used for clustering. A heatmap of `M1` is attached to the left of the GO similarity heatmap so that
#' the group-specific (or list-specific) patterns can be easily observed and to corresponded to GO functions.
#'
#' Argument `heatmap_param` controls several parameters for heatmap `M1`:
#'
#' - `transform`: A self-defined function to transform the data for heatmap visualization. The most typical case is to transform adjusted p-values by `-log10(x)`.
#' - `breaks`: break values for color interpolation.
#' - `col`: The corresponding values for `breaks`.
#' - `labels`: The corresponding labels.
#' - `name`: Legend title.
#' @export
#' @examples
#' \donttest{
#' # perform functional enrichment on the signatures genes from cola anlaysis 
#' require(cola)
#' data(golub_cola) 
#' res = golub_cola["ATC:skmeans"]
#' require(hu6800.db)
#' x = hu6800ENTREZID
#' mapped_probes = mappedkeys(x)
#' id_mapping = unlist(as.list(x[mapped_probes]))
#' lt = functional_enrichment(res, k = 3, id_mapping = id_mapping) # you can check the value of `lt`
#'
#' # a list of data frames
#' simplifyGOFromMultipleLists(lt, padj_cutoff = 0.001)
#'
#' # a list of numeric values
#' lt2 = lapply(lt, function(x) structure(x$p.adjust, names = x$ID))
#' simplifyGOFromMultipleLists(lt2, padj_cutoff = 0.001)
#'
#' # a list of GO IDS
#' lt3 = lapply(lt, function(x) x$ID[x$p.adjust < 0.001])
#' simplifyGOFromMultipleLists(lt3)
#' }
simplifyGOFromMultipleLists = function(lt, go_id_column = NULL, 
	padj_column = NULL, padj_cutoff = 1e-2,
	filter = function(x) any(x < padj_cutoff), default = 1, 
	ont = NULL, db = 'org.Hs.eg.db', measure = "Sim_XGraSM_2013",
	heatmap_param = list(NULL), show_barplot = TRUE,
	method = "binary_cut", control = list(), 
	min_term = NULL, verbose = TRUE, column_title = NULL, ...) {

	n = length(lt)

	if(is.data.frame(lt[[1]])) {

		if(is.null(go_id_column)) {
			go_id_column = which(sapply(lt[[1]], function(x) all(grepl("^GO:\\d+$", x))))[1]
			if(length(go_id_column) == 0) {
				if(!is.null(rownames(lt[[1]]))) {
					go_id_column = rownames
					if(is.null(rownames(lt[[1]]))) {
						stop_wrap("Cannot find the GO ID column in the data frames. Please explicitly set argument `go_id_column`.")
					}
					if(verbose) {
						message_wrap("Use row names of the data frame as `go_id_column`.")
					}
				} else {
					stop_wrap("Cannot find the GO ID column in the data frames. Please explicitly set argument `go_id_column`.")
				}
			} else {
				if(verbose) {
					message_wrap(qq("Use column '@{colnames(lt[[1]])[go_id_column]}' as `go_id_column`."))
				}
			}
		}
		if(is.null(padj_column)) {
			cn = colnames(lt[[1]])
			ind = test_padj_column(cn)
			if(length(ind)) {
				padj_column = ind
				if(verbose) {
					message_wrap(qq("Use column '@{colnames(lt[[1]])[padj_column]}' as `padj_column`."))
				}
			} else {
				stop_wrap("Cannot find the column the contains adjusted p-values in the data frames. Please explicitly set argument `padj_column`.")
			}
		}

		lt = lapply(lt, function(x) {
			if(is.function(go_id_column)) {
				structure(x[, padj_column], names = go_id_column(x))
			} else {
				structure(x[, padj_column], names = x[, go_id_column])
			}
		})
		return(simplifyGOFromMultipleLists(lt, padj_cutoff = padj_cutoff, filter = filter, default = default, ont = ont, db = db, measure = measure, heatmap_param = heatmap_param, 
			show_barplot = show_barplot, method = method, 
			control = control, min_term = min_term, verbose = verbose, column_title = column_title, ...))
		
	} else if(is.character(lt[[1]])) {
		lt = lapply(lt, function(x) structure(rep(1, length(x)), names = x))
		return(simplifyGOFromMultipleLists(lt, default = 0, filter = function(x) TRUE, ont = ont, db = db, measure = measure, show_barplot = show_barplot,
			method = method,
			heatmap_param = list(transform = function(x) x, breaks = c(0, 1), col = c("transparent", "red"), name = "", labels = c("not available", "available")),
			control = control, min_term = min_term, verbose = verbose, column_title = column_title, ...))
	}

	heatmap_param2 = list(transform = NULL, 
		breaks = NULL, col = NULL, labels = NULL, name = "padj"
	)
	for(nm in names(heatmap_param)) {
		heatmap_param2[[nm]] = heatmap_param[[nm]]
	}

	transform = heatmap_param2$transform
	if(is.null(transform)) transform = function(x) -log10(x)
	breaks = heatmap_param2$breaks
	col = heatmap_param2$col
	labels = heatmap_param2$labels
	name = heatmap_param2$name
	if(is.null(name)) name = ""

	if(is.null(breaks) && is.null(col)) {
		digit = ceiling(-log10(padj_cutoff))
		base = padj_cutoff*10^digit
		breaks = c(1, padj_cutoff, base*10^(-digit*2))
		col = c("green", "white", "red")
		labels = gt_render(c("1", qq("@{base}x10<sup>-@{digit}</sup>"), qq("@{base}x10<sup>-@{digit*2}</sup>")))
	} else if(!is.null(breaks) && !is.null(col)) {
		if(length(breaks) != length(col)) {
			stop_wrap("Length of `breaks` must be the same as the length of `col`.")
		}
	}

	all_go_id = unique(unlist(lapply(lt, names)))
	if(!all(grepl("^GO:\\d+$", all_go_id))) {
		stop_wrap("Only GO ID is allowed.")
	}

	m = matrix(default, nrow = length(all_go_id), ncol = n)
	rownames(m) = all_go_id
	colnames(m) = names(lt)
	if(is.null(colnames)) colnames = paste0("Group", 1:n)

	for(i in 1:n) {
		m[names(lt[[i]]), i] = lt[[i]]
	}

	l = apply(m, 1, function(x) {
		if(all(is.na(x))) {
			FALSE
		} else {
			l = filter(x[!is.na(x)])
			if(length(l) == 1) {
				return(l)
			} else {
				return(any(l))
			}
		}
	})
	m = m[l, , drop = FALSE]
	m = t(apply(m, 1, transform))

	if(verbose) message(qq("@{nrow(m)}/@{length(all_go_id)} GO IDs left for clustering."))

	if(length(unique(m[!is.na(m)])) <= 2) {
		col = structure(col, names = breaks)
	} else {
		if(is.null(breaks) && is.null(col)) {
			col = NULL
		} else if(!is.null(breaks) && !is.null(col)) {
			if(length(breaks) != length(col)) {
				stop_wrap("Length of `breaks` and `col` should be the same.")
			}
			col = colorRamp2(transform(breaks), col)
		} else {
			stop_wrap("Arguments `breaks` and `col` should be set at the same time.")
		}
	}

	all_go_id = rownames(m)
	sim_mat = GO_similarity(all_go_id, ont = ont, db = db, measure = measure)
	all_go_id = rownames(sim_mat)  # some GO ids might be removed

	heatmap_legend_param = list()
	heatmap_legend_param$at = transform(breaks)
	heatmap_legend_param$labels = if(is.null(labels)) breaks else labels
	heatmap_legend_param$title = name
	mm = m[all_go_id, , drop = FALSE]

	if(show_barplot) {
		draw_ht = function(align_to) {

			s = sapply(align_to, function(index) max(apply(mm[index, ], 2, function(x) sum(x >= transform(padj_cutoff)))))
			max = max(s)
			by = diff(grid.pretty(c(0, max)))[1]
			Heatmap(mm, col = col, name = if(name == "") NULL else name,
				show_row_names = FALSE, cluster_columns = FALSE,
				border = "black",
				heatmap_legend_param = heatmap_legend_param,
				width = unit(0.5, "cm")*n, use_raster = TRUE,
				left_annotation = rowAnnotation(
					empty = anno_block(width = unit(1.2, "cm"), panel_fun = function(index) {
						if(identical(heatmap_legend_param$labels[1], "not available")) {
							grid.text(qq("Number of GO terms in each cluster"), unit(0, "npc"), 0.5, just = "top", rot = 90, gp = gpar(fontsize = 10))
						} else {
							grid.text(qq("Number of significant GO terms in each cluster (padj < @{padj_cutoff})"), unit(0, "npc"), 0.5, just = "top", rot = 90, gp = gpar(fontsize = 10))
						}
					}),
					bar = anno_link(
						align_to = align_to, side = "left", gap = unit(3, "mm"),
						link_gp = gpar(fill = "#DDDDDD", col = "#AAAAAA"), internal_line = FALSE,
						panel_fun = function(index) {
							v = apply(mm[index, ], 2, function(x) sum(x >= transform(padj_cutoff)))
							grid.text(v[2])
							pushViewport(viewport())
							grid.rect(gp = gpar(fill = "#DDDDDD", col = "#DDDDDD"))
							grid.lines(c(1, 0, 0, 1), c(0, 0, 1, 1), gp = gpar(col = "#AAAAAA"), default.units = "npc")
			    			pushViewport(viewport(xscale = c(0.5, length(v) + 0.5), yscale = c(0, max(v)), height = unit(1, "npc") - unit(2, "mm")))
							grid.rect(seq_along(v), 0, width = 0.6, height = unit(v, "native"), default.units = "native", just = "bottom", gp = gpar(fill = "#444444", col = "#444444"))
							if(length(index)/nrow(mm) > 0.05) {
								grid.yaxis(at = seq(0, max(v), by = by), gp = gpar(col = "#444444", cex = 0.6))
							}
							popViewport()
							popViewport()
						},
						size = s/sum(s)*(unit(1, "npc") - unit(3, "mm")*(length(align_to) - 1) - unit(2, "mm")*length(align_to)) + unit(2, "mm")
					)
				),
				post_fun = function(ht) {
					decorate_annotation("bar", {
						nc = ncol(mm)
						grid.text(colnames(mm), (seq_len(nc)-0.5)/nc*(unit(1, "npc") - unit(5, "mm")), y = -ht_opt$COLUMN_ANNO_PADDING, default.units = "npc", just = "right", rot = 90)
					})
				})
		}
	} else {
		draw_ht = Heatmap(mm, col = col, name = if(name == "") NULL else name,
				show_row_names = FALSE, cluster_columns = FALSE,
				border = "black",
				heatmap_legend_param = heatmap_legend_param,
				width = unit(0.5, "cm")*n, use_raster = TRUE)
	}

	
	if(is.null(min_term)) min_term = round(nrow(sim_mat)*0.02)
	if(is.null(column_title)) column_title = qq("@{length(all_go_id)} GO terms clustered by '@{method}'")

	simplifyGO(sim_mat, ht_list = draw_ht, method = method, 
		verbose = verbose, min_term = min_term, control = control, column_title = column_title, ...)
}

is_p_value = function(x) {
	if(!all(x <= 1 & x >= 0)) {
		return(FALSE)
	}
	v = -log10(x)
	if(sum(v > 2)/length(v) > 0.05) {
		TRUE
	} else {
		FALSE
	}
}

test_padj_column = function(cn) {
	test_cn = c("p.adjust", "p_adjust", "padjust", "padj", "fdr", "FDR", "BH", "p.value", "p-value", "pvalue", "p_value")
	for(x in test_cn) {
		ind = which(cn %in% x)
		if(length(ind)) {
			return(ind[1])
		}
	}
	return(NULL)
}

help_msg = function(fun) {
	
}

.ENV = new.env()
.ENV$ALL_CLUSTERING_FUN = list()
.ENV$ALL_CLUSTERING_METHODS = NULL

get_clustering_method = function(method, control = list()) {
	if(!method %in% .ENV$ALL_CLUSTERING_METHODS) {
		stop_wrap(qq("Clustering method '@{method}' has not been defined yet."))
	}
	fun = .ENV$ALL_CLUSTERING_FUN[[method]]

	fun2 = function(mat) {
		cl = do.call(fun, c(list(mat), control))
		if(is.atomic(cl)) {
			if(length(cl) != nrow(mat)) {
				stop_wrap("Length of clusterings should be the same as number of matrix rows.")
			}
		} else {
			stop_wrap(qq("Clustering method '@{method}' should return an atomic vector."))
		}
		cl = as.numeric(as.factor(cl))

		return(cl)
	}
	
	return(fun2)
}

#' Configure clustering methods
#'
#' @param ... A named list of clustering functions, see in **Details**.
#'
#' @details
#' The user-defined functions should accept at least one argument which is the input matrix. 
#' The second optional argument should always be `...` so that parameters
#' for the clustering function can be passed by the `control` argument from [`cluster_terms()`], [`simplifyGO()`] or [`simplifyEnrichment()`].
#' If users forget to add `...`, it is added internally.
#'
#' Please note, the user-defined function should automatically identify the optimized
#' number of clusters.
#'
#' The function should return a vector of cluster labels. Internally it is converted to numeric labels.
#'
#' @rdname cluster_methods
#' @export
#' @examples
#' register_clustering_methods(
#'     # assume there are 5 groups
#'     random = function(mat, ...) sample(5, nrow(mat), replace = TRUE)
#' )
#' all_clustering_methods()
#' remove_clustering_methods("random")
register_clustering_methods = function(...) {
	
	lt = list(...)
	lt = lapply(lt, function(fun) {
		# just in case people forgot to add the ...
		if(length(formals(fun)) == 1) {
			function(mat, ...) {
				fun(mat)
			}
		} else {
			fun
		}
	})
	lt1 = lt[intersect(names(lt), .ENV$ALL_CLUSTERING_METHODS)]
	lt2 = lt[setdiff(names(lt), .ENV$ALL_CLUSTERING_METHODS)]
	if(length(lt1)) .ENV$ALL_CLUSTERING_FUN[names(lt1)] = lt1
	if(length(lt2)) .ENV$ALL_CLUSTERING_FUN = c(.ENV$ALL_CLUSTERING_FUN, lt2)
	.ENV$ALL_CLUSTERING_METHODS = names(.ENV$ALL_CLUSTERING_FUN)
}

#' @details
#' The default clustering methods are:
#'
#' - `kmeans` see [`cluster_by_kmeans()`].
#' - `dynamicTreeCut` see [`cluster_by_dynamicTreeCut()`].
#' - `mclust` see [`cluster_by_mclust()`].
#' - `apcluster` see [`cluster_by_apcluster()`].
#' - `hdbscan` see [`cluster_by_hdbscan()`].
#' - `fast_greedy` see [`cluster_by_fast_greedy()`].
#' - `louvain` see [`cluster_by_louvain()`].
#' - `walktrap` see [`cluster_by_walktrap()`].
#' - `MCL` see [`cluster_by_MCL()`].
#' - `binary_cut` see [`binary_cut()`].
#'
#' @returns
#' `all_clustering_methods()` returns a vector of clustering method names.
#' @export
#' @rdname cluster_methods
all_clustering_methods = function() {
	x = .ENV$ALL_CLUSTERING_METHODS
	return(x)
}

#' @param method A vector of method names.
#' @export
#' @rdname cluster_methods
remove_clustering_methods = function(method) {
	nm_keep = setdiff(.ENV$ALL_CLUSTERING_METHODS, method)
	.ENV$ALL_CLUSTERING_FUN = .ENV$ALL_CLUSTERING_FUN[nm_keep]
	.ENV$ALL_CLUSTERING_METHODS = nm_keep
}

register_clustering_methods(
	binary_cut = function(mat, ...) binary_cut(mat, ...),
	kmeans = function(mat, ...) cluster_by_kmeans(mat, ...),
	pam = function(mat, ...) cluster_by_pam(mat, ...),
	dynamicTreeCut = function(mat, ...) cluster_by_dynamicTreeCut(mat, ...),
	mclust = function(mat, ...) cluster_by_mclust(mat, ...),
	apcluster = function(mat, ...) cluster_by_apcluster(mat, ...),
	hdbscan = function(mat, ...) cluster_by_hdbscan(mat, ...),
	fast_greedy = function(mat, ...) cluster_by_fast_greedy(mat, ...),
	louvain = function(mat, ...) cluster_by_louvain(mat, ...),
	walktrap = function(mat, ...) cluster_by_walktrap(mat, ...),
	MCL = function(mat, ...) cluster_by_MCL(mat, ...)
)

#' @rdname cluster_methods
#' @export
#' @examples
#' all_clustering_methods()
#' remove_clustering_methods(c("kmeans", "mclust"))
#' all_clustering_methods()
#' reset_clustering_methods()
#' all_clustering_methods()
reset_clustering_methods = function() {
	remove_clustering_methods(all_clustering_methods())
	register_clustering_methods(
		kmeans = function(mat, ...) cluster_by_kmeans(mat, ...),
		pam = function(mat, ...) cluster_by_pam(mat, ...),
		dynamicTreeCut = function(mat, ...) cluster_by_dynamicTreeCut(mat, ...),
		mclust = function(mat, ...) cluster_by_mclust(mat, ...),
		apcluster = function(mat, ...) cluster_by_apcluster(mat, ...),
		hdbscan = function(mat, ...) cluster_by_hdbscan(mat, ...),
		fast_greedy = function(mat, ...) cluster_by_fast_greedy(mat, ...),
		louvain = function(mat, ...) cluster_by_louvain(mat, ...),
		walktrap = function(mat, ...) cluster_by_walktrap(mat, ...),
		MCL = function(mat, ...) cluster_by_MCL(mat, ...),
		binary_cut = function(mat, ...) binary_cut(mat, ...)
	)
}

context("test register_methods")

test_that("test register_methods", {
    expect_that(length(all_clustering_methods()), equals(11))
    remove_clustering_methods(c("binary_cut"))
    expect_that(length(all_clustering_methods()), equals(10))
    reset_clustering_methods()
	expect_that(length(all_clustering_methods()), equals(11))
})

---
title: "The simplifyEnrichment package"
author: "Zuguang Gu (z.gu@dkfz.de)"
date: '`r Sys.Date()`'
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{The simplifyEnrichment package}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

Please go to the package's website: https://jokergoo.github.io/simplifyEnrichment/.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ht_clusters.R
\name{ht_clusters}
\alias{ht_clusters}
\title{Visualize the similarity matrix and the clustering}
\usage{
ht_clusters(
  mat,
  cl,
  dend = NULL,
  col = c("white", "red"),
  draw_word_cloud = TRUE,
  min_term = round(nrow(mat) * 0.01),
  order_by_size = FALSE,
  stat = "pvalue",
  min_stat = ifelse(stat == "count", 5, 0.05),
  exclude_words = character(0),
  max_words = 10,
  word_cloud_grob_param = list(),
  fontsize_range = c(4, 16),
  bg_gp = gpar(fill = "#DDDDDD", col = "#AAAAAA"),
  column_title = NULL,
  ht_list = NULL,
  use_raster = TRUE,
  run_draw = TRUE,
  ...
)
}
\arguments{
\item{mat}{A similarity matrix.}

\item{cl}{Cluster labels inferred from the similarity matrix, e.g. from \code{\link[=cluster_terms]{cluster_terms()}} or \code{\link[=binary_cut]{binary_cut()}}.}

\item{dend}{Used internally.}

\item{col}{A vector of colors that map from 0 to the 97.5^th percentile of the similarity values. The value can also be a color mapping function
generated by \code{\link[circlize:colorRamp2]{circlize::colorRamp2()}}.}

\item{draw_word_cloud}{Whether to draw the word clouds.}

\item{min_term}{Minimal number of functional terms in a cluster. All the clusters
with size less than \code{min_term} are all merged into one separated cluster in the heatmap.}

\item{order_by_size}{Whether to reorder clusters by their sizes. The cluster
that is merged from small clusters (size < \code{min_term}) is always put to the bottom of the heatmap.}

\item{stat}{Type of value for mapping to the font size of keywords in the word clouds. There are two options:
"count": simply number of keywords; "pvalue": enrichment on keywords is performed (by fisher's exact test) and -log10(pvalue) is used to map to font sizes.}

\item{min_stat}{Minimal value for \code{stat} for selecting keywords.}

\item{exclude_words}{Words that are excluded in the word cloud.}

\item{max_words}{Maximal number of words visualized in the word cloud.}

\item{word_cloud_grob_param}{A list of graphic parameters passed to \code{\link[=word_cloud_grob]{word_cloud_grob()}}.}

\item{fontsize_range}{The range of the font size. The value should be a numeric vector with length two.
The font size interpolation is linear.}

\item{bg_gp}{Graphics parameters for controlling word cloud annotation background.}

\item{column_title}{Column title for the heatmap.}

\item{ht_list}{A list of additional heatmaps added to the left of the similarity heatmap.}

\item{use_raster}{Whether to write the heatmap as a raster image.}

\item{run_draw}{Internally used.}

\item{...}{Other arguments passed to \code{\link[ComplexHeatmap:draw-HeatmapList-method]{ComplexHeatmap::draw,HeatmapList-method}}.}
}
\value{
A \code{\link[ComplexHeatmap:HeatmapList-class]{ComplexHeatmap::HeatmapList}} object.
}
\description{
Visualize the similarity matrix and the clustering
}
\examples{
\donttest{
mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
    package = "simplifyEnrichment"))
cl = binary_cut(mat)
ht_clusters(mat, cl, word_cloud_grob_param = list(max_width = 80))
ht_clusters(mat, cl, word_cloud_grob_param = list(max_width = 80),
    order_by_size = TRUE)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simplify.R
\name{simplifyGOFromMultipleLists}
\alias{simplifyGOFromMultipleLists}
\title{Perform simplifyGO analysis with multiple lists of GO IDs}
\usage{
simplifyGOFromMultipleLists(
  lt,
  go_id_column = NULL,
  padj_column = NULL,
  padj_cutoff = 0.01,
  filter = function(x) any(x < padj_cutoff),
  default = 1,
  ont = NULL,
  db = "org.Hs.eg.db",
  measure = "Sim_XGraSM_2013",
  heatmap_param = list(NULL),
  show_barplot = TRUE,
  method = "binary_cut",
  control = list(),
  min_term = NULL,
  verbose = TRUE,
  column_title = NULL,
  ...
)
}
\arguments{
\item{lt}{A data frame, a list of numeric vectors (e.g. adjusted p-values) where each numeric vector has GO IDs as names, or a list of GO IDs.}

\item{go_id_column}{Column index of GO ID if \code{lt} contains a list of data frames.}

\item{padj_column}{Column index of adjusted p-values if \code{lt} contains a list of data frames.}

\item{padj_cutoff}{Cut off for adjusted p-values.}

\item{filter}{A self-defined function for filtering GO IDs. By default it requires GO IDs should be significant in at least one list.}

\item{default}{The default value for the adjusted p-values. See \strong{Details}.}

\item{ont}{Pass to \code{\link[=GO_similarity]{GO_similarity()}}.}

\item{db}{Pass to \code{\link[=GO_similarity]{GO_similarity()}}.}

\item{measure}{Pass to \code{\link[=GO_similarity]{GO_similarity()}}.}

\item{heatmap_param}{Parameters for controlling the heatmap, see \strong{Details}.}

\item{show_barplot}{Whether draw barplots which shows numbers of significant GO terms in clusters.}

\item{method}{Pass to \code{\link[=simplifyGO]{simplifyGO()}}.}

\item{control}{Pass to \code{\link[=simplifyGO]{simplifyGO()}}.}

\item{min_term}{Pass to \code{\link[=simplifyGO]{simplifyGO()}}.}

\item{verbose}{Pass to \code{\link[=simplifyGO]{simplifyGO()}}.}

\item{column_title}{Pass to \code{\link[=simplifyGO]{simplifyGO()}}.}

\item{...}{Pass to \code{\link[=simplifyGO]{simplifyGO()}}.}
}
\description{
Perform simplifyGO analysis with multiple lists of GO IDs
}
\details{
The input data can have three types of formats:
\itemize{
\item A list of numeric vectors of adjusted p-values where each vector has the GO IDs as names.
\item A data frame. The column of the GO IDs can be specified with \code{go_id_column} argument and the column of the adjusted p-values can be
specified with \code{padj_column} argument. If these columns are not specified, they are automatically identified. The GO ID column
is found by checking whether a column contains all GO IDs. The adjusted p-value column is found by comparing the column names of the
data frame to see whether it might be a column for adjusted p-values. These two columns are used to construct a numeric vector
with GO IDs as names.
\item A list of character vectors of GO IDs. In this case, each character vector is changed to a numeric vector where
all values take 1 and the original GO IDs are used as names of the vector.
}

Now let's assume there are \code{n} GO lists, we first construct a global matrix where columns correspond to the \code{n} GO lists and rows correspond
to the "union" of all GO IDs in the lists. The value for the ith GO ID and in the jth list are taken from the corresponding numeric vector
in \code{lt}. If the jth vector in \code{lt} does not contain the ith GO ID, the value defined by \code{default} argument is taken there (e.g. in most cases the numeric
values are adjusted p-values, \code{default} is set to 1). Let's call this matrix as \code{M0}.

Next step is to filter \code{M0} so that we only take a subset of GO IDs of interest. We define a proper function via argument \code{filter} to remove
GO IDs that are not important for the analysis. Functions for \code{filter} is applied to every row in \code{M0} and \code{filter} function needs
to return a logical value to decide whether to remove the current GO ID. For example, if the values in \code{lt} are adjusted p-values, the \code{filter} function
can be set as \code{function(x) any(x < padj_cutoff)} so that the GO ID is kept as long as it is signfiicant in at least one list. After the filter, let's call
the filtered matrix \code{M1}.

GO IDs in \code{M1} (row names of \code{M1}) are used for clustering. A heatmap of \code{M1} is attached to the left of the GO similarity heatmap so that
the group-specific (or list-specific) patterns can be easily observed and to corresponded to GO functions.

Argument \code{heatmap_param} controls several parameters for heatmap \code{M1}:
\itemize{
\item \code{transform}: A self-defined function to transform the data for heatmap visualization. The most typical case is to transform adjusted p-values by \code{-log10(x)}.
\item \code{breaks}: break values for color interpolation.
\item \code{col}: The corresponding values for \code{breaks}.
\item \code{labels}: The corresponding labels.
\item \code{name}: Legend title.
}
}
\examples{
\donttest{
# perform functional enrichment on the signatures genes from cola anlaysis 
require(cola)
data(golub_cola) 
res = golub_cola["ATC:skmeans"]
require(hu6800.db)
x = hu6800ENTREZID
mapped_probes = mappedkeys(x)
id_mapping = unlist(as.list(x[mapped_probes]))
lt = functional_enrichment(res, k = 3, id_mapping = id_mapping) # you can check the value of `lt`

# a list of data frames
simplifyGOFromMultipleLists(lt, padj_cutoff = 0.001)

# a list of numeric values
lt2 = lapply(lt, function(x) structure(x$p.adjust, names = x$ID))
simplifyGOFromMultipleLists(lt2, padj_cutoff = 0.001)

# a list of GO IDS
lt3 = lapply(lt, function(x) x$ID[x$p.adjust < 0.001])
simplifyGOFromMultipleLists(lt3)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_cut.R
\name{select_cutoff}
\alias{select_cutoff}
\title{Select the cutoff for binary cut}
\usage{
select_cutoff(
  mat,
  cutoff = seq(0.6, 0.98, by = 0.01),
  verbose = se_opt$verbose,
  ...
)
}
\arguments{
\item{mat}{A similarity matrix.}

\item{cutoff}{A list of cutoffs to test. Note the range of the cutoff values should be inside \verb{[0.5, 1]}.}

\item{verbose}{Whether to print messages.}

\item{...}{Pass to \code{\link[=binary_cut]{binary_cut()}}.}
}
\description{
Select the cutoff for binary cut
}
\details{
Binary cut is applied to each cutoff and the clustering results are evaluated by following metrics:
\itemize{
\item difference score, calculated by \code{\link[=difference_score]{difference_score()}}.
\item number of clusters.
\item block mean, which is the mean similarity in the blocks in the diagonal of the heatmap.
}
}
\examples{
\donttest{
mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
    package = "simplifyEnrichment"))
select_cutoff(mat)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/word_cloud.R
\name{anno_word_cloud_from_GO}
\alias{anno_word_cloud_from_GO}
\title{Word cloud annotations from GO}
\usage{
anno_word_cloud_from_GO(
  align_to,
  go_id,
  stat = c("pvalue", "count"),
  min_stat = ifelse(stat == "count", 5, 0.05),
  term = NULL,
  exclude_words = NULL,
  ...
)
}
\arguments{
\item{align_to}{The same format as in \code{anno_word_cloud}.}

\item{go_id}{The value should be in the same format as \code{align_to}. If \code{go_id} is a vector, it should have the
same length as \code{align_to}, and if \code{go_id} is a list, note, e.g. \code{length(go_id[[1]])} is not necessarily equal to \verb{length(align_to[[1]]}.
If \code{align_to} is a categorical vector and \code{go_id} is a list, names of \code{go_id} should have overlap to the levels in \code{align_to}.}

\item{stat}{What type of value to map to font sizes of the keywords. There are two possible values. "pvalue": enrichment is applied to keywords and -log10(p-value)
is used to map to font size; "count": simply word frequency of keywords.}

\item{min_stat}{Minimal value for \code{stat} for selecting keywords.}

\item{term}{Alternatively the GO description can be set via the \code{term} argument. The same format as in \code{anno_word_cloud}.}

\item{exclude_words}{The words excluced for construcing word cloud. Some words are internally exclucded: \code{c("via", "protein", "factor", "side", "type", "specific")}.}

\item{...}{All other arguments passed to \code{anno_word_cloud}.}
}
\description{
Word cloud annotations from GO
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/z.register_methods.R
\name{register_clustering_methods}
\alias{register_clustering_methods}
\alias{all_clustering_methods}
\alias{remove_clustering_methods}
\alias{reset_clustering_methods}
\title{Configure clustering methods}
\usage{
register_clustering_methods(...)

all_clustering_methods()

remove_clustering_methods(method)

reset_clustering_methods()
}
\arguments{
\item{...}{A named list of clustering functions, see in \strong{Details}.}

\item{method}{A vector of method names.}
}
\value{
\code{all_clustering_methods()} returns a vector of clustering method names.
}
\description{
Configure clustering methods
}
\details{
The user-defined functions should accept at least one argument which is the input matrix.
The second optional argument should always be \code{...} so that parameters
for the clustering function can be passed by the \code{control} argument from \code{\link[=cluster_terms]{cluster_terms()}}, \code{\link[=simplifyGO]{simplifyGO()}} or \code{\link[=simplifyEnrichment]{simplifyEnrichment()}}.
If users forget to add \code{...}, it is added internally.

Please note, the user-defined function should automatically identify the optimized
number of clusters.

The function should return a vector of cluster labels. Internally it is converted to numeric labels.

The default clustering methods are:
\itemize{
\item \code{kmeans} see \code{\link[=cluster_by_kmeans]{cluster_by_kmeans()}}.
\item \code{dynamicTreeCut} see \code{\link[=cluster_by_dynamicTreeCut]{cluster_by_dynamicTreeCut()}}.
\item \code{mclust} see \code{\link[=cluster_by_mclust]{cluster_by_mclust()}}.
\item \code{apcluster} see \code{\link[=cluster_by_apcluster]{cluster_by_apcluster()}}.
\item \code{hdbscan} see \code{\link[=cluster_by_hdbscan]{cluster_by_hdbscan()}}.
\item \code{fast_greedy} see \code{\link[=cluster_by_fast_greedy]{cluster_by_fast_greedy()}}.
\item \code{louvain} see \code{\link[=cluster_by_louvain]{cluster_by_louvain()}}.
\item \code{walktrap} see \code{\link[=cluster_by_walktrap]{cluster_by_walktrap()}}.
\item \code{MCL} see \code{\link[=cluster_by_MCL]{cluster_by_MCL()}}.
\item \code{binary_cut} see \code{\link[=binary_cut]{binary_cut()}}.
}
}
\examples{
register_clustering_methods(
    # assume there are 5 groups
    random = function(mat, ...) sample(5, nrow(mat), replace = TRUE)
)
all_clustering_methods()
remove_clustering_methods("random")
all_clustering_methods()
remove_clustering_methods(c("kmeans", "mclust"))
all_clustering_methods()
reset_clustering_methods()
all_clustering_methods()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_cut.R
\name{area_above_ecdf}
\alias{area_above_ecdf}
\title{Area above the eCDF curve}
\usage{
area_above_ecdf(x)
}
\arguments{
\item{x}{A vector of similarity values.}
}
\value{
A numeric value.
}
\description{
Area above the eCDF curve
}
\details{
Denote \code{F(x)} as the eCDF (empirical Cumulative Distribution Function) of the similarity vector \code{x},
this function calculates the area above the eCDF curve, which is \verb{1 - \\int_0^1 F(x)dx}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/word_cloud.R
\name{anno_word_cloud}
\alias{anno_word_cloud}
\title{Word cloud annotations}
\usage{
anno_word_cloud(
  align_to,
  term,
  exclude_words = NULL,
  max_words = 10,
  word_cloud_grob_param = list(),
  fontsize_range = c(4, 16),
  value_range = NULL,
  bg_gp = gpar(fill = "#DDDDDD", col = "#AAAAAA"),
  side = c("right", "left"),
  add_new_line = FALSE,
  count_words_param = list(),
  ...,
  return_gbl = FALSE
)
}
\arguments{
\item{align_to}{How to align the annotations to the heatmap. Similar as in \code{ComplexHeatmap::anno_link}, the value of \code{align_to}
can be a list of row indices or a categorical vector where each vector in the list corresponds to a word cloud.
If it is a categorical vector, rows with the same level correspond to a same word cloud.
If \code{align_to} is a categorical vector and \code{term} is a list, names of \code{term} should have overlap to the levels in \code{align_to}.
When \code{align_to} is set as a categorical vector, normally the same value is set to \code{row_split} in the main heatmap so that each row slice
can correspond to a word cloud.}

\item{term}{The description text used for constructing the word clouds. The value should have the same format as \code{align_to}. If \code{align_to}
is a list, \code{term} should also be a list. In this case, the length of vectors in \code{term} is not necessarily the same
as in \code{align_to}. E.g. \code{length(term[[1]])} is not necessarily equal to \verb{length(align_to[[1]]}. If \code{align_to}
is a categorical vector, \code{term} should also be a character vector with the same length as \code{align_to}.
To make it more genrall, when \code{align_to} is a list, \code{term} can also be a list of data frames where the first column contains
keywords and the second column contains numeric values that will be mapped to font sizes in the word clouds.}

\item{exclude_words}{The words excluced for construcing word cloud.}

\item{max_words}{Maximal number of words visualized in the word cloud.}

\item{word_cloud_grob_param}{A list of graphics parameters passed to \code{word_cloud_grob}.}

\item{fontsize_range}{The range of the font size. The value should be a numeric vector with length two.
The font size interpolation is linear.}

\item{value_range}{The range of values to map to font sizes.}

\item{bg_gp}{Graphics parameters for controlling the background.}

\item{side}{Side of the annotation relative to the heatmap.}

\item{add_new_line}{Whether to add new line after every word? If \code{TRUE}, each word will be in a separated line.}

\item{count_words_param}{A list of parameters passed to \code{count_words}.}

\item{...}{Other parameters.}

\item{return_gbl}{Internally used.}
}
\description{
Word cloud annotations
}
\details{
The word cloud annotation is constructed by \code{ComplexHeatmap::anno_link}.

If the annotation is failed to construct or no keyword is found, the function returns a \code{ComplexHeatmap::anno_empty} with 1px width.

English stop words, punctuation and numbers are removed by default when counting words. As specific stop words might
coincide with gene or pathway names, and numbers in genes names might be meaningful it is recommended to adjust this
behaviour by passing appropriate arguments to the \code{count_words} function using \code{count_words_param}.
}
\examples{
gm = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", package = "simplifyEnrichment"))
go_id = rownames(gm)
go_term = AnnotationDbi::select(GO.db::GO.db, keys = go_id, columns = "TERM")$TERM

split = sample(letters[1:4], 100, replace = TRUE)
align_to = split(1:100, split)
term = lapply(letters[1:4], function(x) sample(go_term, sample(100:400, 1)))
names(term) = letters[1:4]

require(ComplexHeatmap)
mat = matrix(rnorm(100*10), nrow = 100)
Heatmap(mat, cluster_rows = FALSE, row_split = split, 
	right_annotation = rowAnnotation(foo = anno_word_cloud(align_to, term)))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/node_partition.R
\name{partition_by_kmeans}
\alias{partition_by_kmeans}
\alias{partition_by_pam}
\alias{partition_by_hclust}
\alias{partition_by_kmeanspp}
\title{Partition the matrix}
\usage{
partition_by_kmeans(mat, n_repeats = 10)

partition_by_pam(mat)

partition_by_hclust(mat)

partition_by_kmeanspp(mat)
}
\arguments{
\item{mat}{The submatrix in the binary cut clustering process.}

\item{n_repeats}{Number of repeated runs of k-means clustering.}
}
\value{
All partitioning functions split the matrix into two groups and return a categorical vector of
labels of 1 and 2.
}
\description{
Partition the matrix
}
\details{
These functions can be set to the \code{partition_fun} argument in \code{\link[=binary_cut]{binary_cut()}}.

\code{partition_by_kmeans()}: Since k-means clustering brings randomness, this function performs
k-means clustering several times (controlled by \code{n_repeats}) and uses the final consensus partitioning results.

\code{partition_by_pam()}: The clustering is performed by \code{\link[cluster:pam]{cluster::pam()}} with the \code{pamonce} argument set to 5.

\code{partition_by_hclust()}: The "ward.D2" clusering method was used.

\code{partition_by_kmeanspp()}: It uses the kmeanspp method from the \strong{flexclust} package.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dend_utils.R
\name{dend_node_apply}
\alias{dend_node_apply}
\alias{edit_node}
\title{Apply functions on every node in a dendrogram}
\usage{
dend_node_apply(dend, fun)

edit_node(dend, fun = function(d, index) d)
}
\arguments{
\item{dend}{A \code{dendrogram} object.}

\item{fun}{A self-defined function.}
}
\value{
\code{dend_node_apply()} returns a vector or a list, depends on whether \code{fun} returns a scalar or more complex values.

\code{edit_node()} returns a \code{dendrogram} object.
}
\description{
Apply functions on every node in a dendrogram
}
\details{
\code{dend_node_apply()} returns a vector or a list as the same length as the number of nodes in the dendrogram.

The self-defined function can have one single argument which is the sub-dendrogram at a certain node.
E.g. to get the number of members at every node:

\if{html}{\out{<div class="sourceCode">}}\preformatted{dend_node_apply(dend, function(d) attr(d, "members"))
}\if{html}{\out{</div>}}

The self-defined function can have a second argument, which is the index of current sub-dendrogram in
the complete dendrogram. E.g. \code{dend[[1]]} is the first child node of the complete dendrogram and
\code{dend[[c(1, 2)]]} is the second child node of \code{dend[[1]]}, et al. This makes that at a certain node,
it is possible to get information of its child nodes and parent nodes.

\if{html}{\out{<div class="sourceCode">}}\preformatted{dend_node_apply(dend, function(d, index) \{
    dend[[c(index, 1)]] # is the first child node of d, or simply d[[1]]
    dend[[index[-length(index)]]] # is the parent node of d
    ...
\})
}\if{html}{\out{</div>}}

Note for the top node, the value of \code{index} is \code{NULL}.

In \code{edit_node()}, if \code{fun} only has one argument, it is basically the same as \code{\link[stats:dendrapply]{stats::dendrapply()}},
but it can have a second argument which is the index of the node in the dendrogram,
which makes it possible to get information of child nodes and parent nodes for
a specific node.

As an example, we first assign random values to every node in the dendrogram:

\if{html}{\out{<div class="sourceCode">}}\preformatted{mat = matrix(rnorm(100), 10)
dend = as.dendrogram(hclust(dist(mat)))
dend = edit_node(dend, function(d) \{attr(d, 'score') = runif(1); d\})
}\if{html}{\out{</div>}}

Then for every node, we take the maximal absolute difference to all its child nodes
and parent node as the attribute \code{abs_diff}.

\if{html}{\out{<div class="sourceCode">}}\preformatted{dend = edit_node(dend, function(d, index) \{
    n = length(index)
    s = attr(d, "score")
    if(is.null(index)) \{  # d is the top node
        s_children = sapply(d, function(x) attr(x, "score"))
        s_parent = NULL
    \} else if(is.leaf(d)) \{ # d is the leaf
        s_children = NULL
        s_parent = attr(dend[[index[-n]]], "score")
    \} else \{
        s_children = sapply(d, function(x) attr(x, "score"))
        s_parent = attr(dend[[index[-n]]], "score")
    \}
    abs_diff = max(abs(s - c(s_children, s_parent)))
    attr(d, "abs_diff") = abs_diff
    return(d)
\})
}\if{html}{\out{</div>}}
}
\examples{
mat = matrix(rnorm(100), 10)
dend = as.dendrogram(hclust(dist(mat)))
# number of members on every node
dend_node_apply(dend, function(d) attr(d, "members"))
# the depth on every node
dend_node_apply(dend, function(d, index) length(index))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ht_clusters.R
\name{scale_fontsize}
\alias{scale_fontsize}
\title{Scale font size}
\usage{
scale_fontsize(x, rg = c(1, 30), fs = c(4, 16))
}
\arguments{
\item{x}{A numeric vector.}

\item{rg}{The range.}

\item{fs}{Range of the font size.}
}
\value{
A numeric vector.
}
\description{
Scale font size
}
\details{
It is a linear interpolation.
}
\examples{
x = runif(10, min = 1, max = 20)
# scale x to fontsize 4 to 16.
scale_fontsize(x)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compare_methods.R
\name{cmp_make_clusters}
\alias{cmp_make_clusters}
\alias{cmp_make_plot}
\alias{compare_clustering_methods}
\title{Compare clustering methods}
\usage{
cmp_make_clusters(
  mat,
  method = setdiff(all_clustering_methods(), "mclust"),
  verbose = TRUE
)

cmp_make_plot(mat, clt, plot_type = c("mixed", "heatmap"), nrow = 3)

compare_clustering_methods(
  mat,
  method = setdiff(all_clustering_methods(), "mclust"),
  plot_type = c("mixed", "heatmap"),
  nrow = 3,
  verbose = TRUE
)
}
\arguments{
\item{mat}{The similarity matrix.}

\item{method}{Which methods to compare. All available methods are in \code{\link[=all_clustering_methods]{all_clustering_methods()}}.
A value of \code{"all"} takes all available methods. By default "mclust" is excluded because its long runtime.}

\item{verbose}{Whether to print messages.

Ddetails
The function compares following default clustering methods by default:

-\code{kmeans} see \code{cluster_by_kmeans}.
-\code{pam} see \code{cluster_by_pam}.
-\code{dynamicTreeCut} see \code{cluster_by_dynamicTreeCut}.
-\code{mclust} see \code{cluster_by_mclust}. By default it is not included.
-\code{apcluster} see \code{cluster_by_apcluster}.
-\code{hdbscan} see \code{cluster_by_hdbscan}.
-\code{fast_greedy} see \code{cluster_by_fast_greedy}.
-\code{louvain} see \code{cluster_by_louvain}.
-\code{walktrap} see \code{cluster_by_walktrap}.
-\code{MCL} see \code{cluster_by_MCL}.
-\code{binary_cut} see \code{binary_cut}.

Also the user-defined methods in \code{all_clustering_methods} are also compared.}

\item{clt}{A list of clusterings from \code{cmp_make_clusters()}.}

\item{plot_type}{What type of plots to make. See \strong{Details}.}

\item{nrow}{Number of rows of the layout when \code{plot_type} is set to \code{"heatmap"}.}
}
\value{
\code{cmp_make_clusters()} returns a list of cluster label vectors from different clustering methods.

\code{cmp_make_plot()} returns no value.

\code{compare_clustering_methods()} returns no value.
}
\description{
Compare clustering methods
}
\details{
For \code{cmp_make_plot()}, if \code{plot_type} is the default value \code{"mixed"}, a figure with three panels will be generated:
\itemize{
\item A heatmap of the similarity matrix with different classifications as row annotations.
\item A heatmap of the pair-wise concordance of the classifications of every two clustering methods.
\item Barplots of the difference scores for each method (calculated by \code{difference_score}), the number
of clusters (total clusters and the clusters with size >= 5) and the mean similarity of the terms
that are in the same clusters.
}

If \code{plot_type} is \code{"heatmap"}. There are heatmaps for the similarity matrix under clusterings
from different methods. The last panel is a table with the number of clusters under different
clusterings.

\code{compare_clustering_methods()} is basically a wrapper function of \code{cmp_make_clusters()} and \code{cmp_make_plot()}.
}
\examples{
\donttest{
mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
    package = "simplifyEnrichment"))
compare_clustering_methods(mat)
compare_clustering_methods(mat, plot_type = "heatmap")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiny.R
\name{export_to_shiny_app}
\alias{export_to_shiny_app}
\title{Interactively visualize the similarity heatmap}
\usage{
export_to_shiny_app(mat, cl = binary_cut(mat))
}
\arguments{
\item{mat}{A similarity matrix.}

\item{cl}{Cluster labels inferred from the similarity matrix, e.g. from \code{\link[=cluster_terms]{cluster_terms()}} or \code{\link[=binary_cut]{binary_cut()}}.}
}
\value{
A shiny application.
}
\description{
Interactively visualize the similarity heatmap
}
\examples{
if(interactive()) {
    mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", 
        package = "simplifyEnrichment"))
    cl = binary_cut(mat)
    export_to_shiny_app(mat, cl)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/word_cloud.R
\name{word_cloud_grob}
\alias{word_cloud_grob}
\alias{widthDetails.word_cloud}
\alias{heightDetails.word_cloud}
\title{A simple grob for the word cloud}
\usage{
word_cloud_grob(
  text,
  fontsize,
  line_space = unit(4, "pt"),
  word_space = unit(4, "pt"),
  max_width = unit(80, "mm"),
  col = function(fs) circlize::rand_color(length(fs), luminosity = "dark"),
  add_new_line = FALSE,
  test = FALSE
)

\method{widthDetails}{word_cloud}(x)

\method{heightDetails}{word_cloud}(x)
}
\arguments{
\item{text}{A vector of words.}

\item{fontsize}{The corresponding font size. With the frequency of the words known, \code{scale_fontsize} can be used to linearly interpolate frequencies to font sizes.}

\item{line_space}{Space between lines. The value can be a \code{grid::unit} object or a numeric scalar which is measured in mm.}

\item{word_space}{Space between words. The value can be a \code{grid::unit} object or a numeric scalar which is measured in mm.}

\item{max_width}{The maximal width of the viewport to put the word cloud. The value can be a \code{grid::unit} object or a numeric scalar which is measured in mm.
Note this might be larger than the final width of the returned grob object.}

\item{col}{Colors for the words. The value can be a vector, in numeric or character, which should have the same
length as \code{text}. Or it is a self-defined function that takes the font size vector as
the only argument. The function should return a color vector. See Examples.}

\item{add_new_line}{Whether to add new line after every word? If \code{TRUE}, each word will be in a separated line.}

\item{test}{Internally used. It basically adds borders to the words and the viewport.}

\item{x}{The \code{word_cloud} grob returned by \code{word_cloud_grob}.}
}
\value{
A \code{grid::grob} object. The width and height of the grob can be get by \code{grid::grobWidth} and \code{grid::grobHeight}.
}
\description{
A simple grob for the word cloud
}
\examples{
# very old R versions do not have strrep() function
if(!exists("strrep")) {
    strrep = function(x, i) paste(rep(x, i), collapse = "")
}
words = sapply(1:30, function(x) strrep(sample(letters, 1), sample(3:10, 1)))
require(grid)
gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
    max_width = 100)
grid.newpage(); grid.draw(gb)

# color as a single scalar
gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
    max_width = 100, col = 1)
grid.newpage(); grid.draw(gb)

# color as a vector
gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
    max_width = 100, col = 1:30)
grid.newpage(); grid.draw(gb)

# color as a function
require(circlize)
col_fun = colorRamp2(c(5, 17, 30), c("blue", "black", "red"))
gb = word_cloud_grob(words, fontsize = runif(30, min = 5, max = 30), 
    max_width = 100, col = function(fs) col_fun(fs))
grid.newpage(); grid.draw(gb)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarity_GO.R
\name{GO_similarity}
\alias{GO_similarity}
\alias{guess_ont}
\alias{random_GO}
\title{Calculate Gene Ontology (GO) semantic similarity matrix}
\usage{
GO_similarity(
  go_id,
  ont = NULL,
  db = "org.Hs.eg.db",
  measure = "Sim_XGraSM_2013"
)

guess_ont(go_id, db = "org.Hs.eg.db")

random_GO(n, ont = c("BP", "CC", "MF"), db = "org.Hs.eg.db")
}
\arguments{
\item{go_id}{A vector of GO IDs.}

\item{ont}{Sub-ontology of GO. Value should be one of "BP", "CC" or "MF". If it is not specified,
the function automatically identifies it by random sampling 10 IDs from \code{go_id} (see \code{guess_ont()}).}

\item{db}{Annotation database. It should be an OrgDb package name from \url{https://bioconductor.org/packages/release/BiocViews.html#___OrgDb}. The value
can also directly be an \code{OrgDb} object.}

\item{measure}{Semantic measure for the GO similarity, pass to \code{\link[simona:term_sim]{simona::term_sim()}}. All valid values are in \code{\link[simona:all_methods]{simona::all_term_sim_methods()}}.}

\item{n}{Number of GO IDs.}
}
\value{
\code{GO_similarity()} returns a symmetric matrix.

\code{guess_ont()} returns a single character scalar of "BP", "CC" or "MF".
If there are more than one ontologies detected. It returns \code{NULL}.

\code{random_GO()} returns a vector of GO IDs.
}
\description{
Calculate Gene Ontology (GO) semantic similarity matrix
}
\details{
The default similarity method is "Sim_XGraSM_2013". Since the semantic similarities are calculated based on gene annotations to GO terms,
I suggest users also try the following methods:
\itemize{
\item \code{"Sim_Lin_1998"}
\item \code{"Sim_Resnik_1999"}
\item \code{"Sim_Relevance_2006"}
\item \code{"Sim_SimIC_2010"}
\item \code{"Sim_XGraSM_2013"}
\item \code{"Sim_EISI_2015"}
\item \code{"Sim_AIC_2014"}
\item \code{"Sim_Wang_2007"}
\item \code{"Sim_GOGO_2018"}
}

In \code{guess_ont()}, only 10 random GO IDs are checked.

In \code{random_GO()}, only GO terms with gene annotations are sampled.
}
\examples{
\donttest{
go_id = random_GO(100)
mat = GO_similarity(go_id)
}
\donttest{
go_id = random_GO(100)
guess_ont(go_id)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simplify.R
\name{simplifyGO}
\alias{simplifyGO}
\alias{simplifyEnrichment}
\title{Simplify Gene Ontology (GO) enrichment results}
\usage{
simplifyGO(
  mat,
  method = "binary_cut",
  control = list(),
  plot = TRUE,
  verbose = TRUE,
  column_title = qq("@{nrow(mat)} GO terms clustered by '@{method}'"),
  ht_list = NULL,
  ...
)

simplifyEnrichment(...)
}
\arguments{
\item{mat}{A GO similarity matrix. You can also provide a vector of GO IDs to this argument.}

\item{method}{Method for clustering the matrix. See \code{\link[=cluster_terms]{cluster_terms()}}.}

\item{control}{A list of parameters for controlling the clustering method, passed to \code{\link[=cluster_terms]{cluster_terms()}}.}

\item{plot}{Whether to make the heatmap.}

\item{verbose}{Whether to print messages.}

\item{column_title}{Column title for the heatmap.}

\item{ht_list}{A list of additional heatmaps added to the left of the similarity heatmap.}

\item{...}{Arguments passed to \code{\link[=ht_clusters]{ht_clusters()}}.}
}
\value{
A data frame with two columns: GO IDs and cluster labels.
}
\description{
Simplify Gene Ontology (GO) enrichment results
}
\details{
This is basically a wrapper function that it first runs \code{\link[=cluster_terms]{cluster_terms()}} to cluster
GO terms and then runs \code{\link[=ht_clusters]{ht_clusters()}} to visualize the clustering.

The arguments in \code{simplifyGO()} passed to \code{ht_clusters()} are:
\itemize{
\item \code{draw_word_cloud}: Whether to draw the word clouds.
\item \code{min_term}: Minimal number of GO terms in a cluster. All the clusters
with size less than \code{min_term} are all merged into one single cluster in the heatmap.
\item \code{order_by_size}: Whether to reorder GO clusters by their sizes. The cluster
that is merged from small clusters (size < \code{min_term}) is always put to the bottom of the heatmap.
\item \code{stat}: What values of keywords are used to map to font sizes in the word clouds.
\item \code{exclude_words}: Words that are excluded in the word cloud.
\item \code{max_words}: Maximal number of words visualized in the word cloud.
\item \code{word_cloud_grob_param}: A list of graphic parameters passed to \code{\link[=word_cloud_grob]{word_cloud_grob()}}.
\item \code{fontsize_range} The range of the font size. The value should be a numeric vector with length two.
The minimal font size is mapped to word frequency value of 1 and the maximal font size is mapped
to the maximal word frequency. The font size interlopation is linear.
\item \code{bg_gp}: Graphic parameters for controlling the background of word cloud annotations.
}
}
\examples{
\donttest{
set.seed(123)
go_id = random_GO(500)
mat = GO_similarity(go_id)
df = simplifyGO(mat, word_cloud_grob_param = list(max_width = 80))
head(df)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keywords.R
\name{keyword_enrichment_from_GO}
\alias{keyword_enrichment_from_GO}
\title{Keyword enrichment for GO terms}
\usage{
keyword_enrichment_from_GO(go_id, min_bg = 5, min_term = 2)
}
\arguments{
\item{go_id}{A vector of GO IDs.}

\item{min_bg}{Minimal number of GO terms (in the background, i.e. all GO temrs in the GO database) that contain a specific keyword.}

\item{min_term}{Minimal number of GO terms (GO terms in \code{go_id}) that contain a specific keyword.}
}
\value{
A data frame with keyword enrichment results.
}
\description{
Keyword enrichment for GO terms
}
\details{
The enrichment is applied by Fisher's exact test. For a keyword, there is the following 2x2 contigency table:

\if{html}{\out{<div class="sourceCode">}}\preformatted{                      | contains the keyword | does not contain the keyword
    In the GO set     |          s11         |          s12
    Not in the GO set |          s21         |          s22
}\if{html}{\out{</div>}}

where \code{s11}, \code{s12}, \code{s21} and \code{s22} are the counts of GO terms in the four categories.
}
\examples{
\donttest{
go_id = random_GO(100)
keyword_enrichment_from_GO(go_id)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simple_plot.R
\name{summarizeGO}
\alias{summarizeGO}
\title{A simplified way to visualize enrichment in GO clusters}
\usage{
summarizeGO(
  go_id,
  value = NULL,
  aggregate = mean,
  method = "binary_cut",
  control = list(),
  verbose = TRUE,
  axis_label = "Value",
  title = "",
  legend_title = axis_label,
  min_term = round(nrow(mat) * 0.01),
  stat = "pvalue",
  min_stat = ifelse(stat == "count", 5, 0.05),
  exclude_words = character(0),
  max_words = 6,
  word_cloud_grob_param = list(),
  fontsize_range = c(4, 16),
  bg_gp = gpar(fill = "#DDDDDD", col = "#AAAAAA")
)
}
\arguments{
\item{go_id}{A vector of GO IDs.}

\item{value}{A list of numeric value associate with \code{go_id}. We suggest to use \code{-log10(p.adjust)} or \verb{-log2(fold enrichment)} as the values.}

\item{aggregate}{Function to aggregate values in each GO cluster.}

\item{method}{Method for clustering the matrix. See \code{\link[=cluster_terms]{cluster_terms()}}.}

\item{control}{A list of parameters for controlling the clustering method, passed to \code{\link[=cluster_terms]{cluster_terms()}}.}

\item{verbose}{Whether to print messages.}

\item{axis_label}{X-axis label.}

\item{title}{Title for the whole plot.}

\item{legend_title}{Title for the legend.}

\item{min_term}{Minimal number of functional terms in a cluster. All the clusters
with size less than \code{min_term} are all merged into one separated cluster in the heatmap.}

\item{stat}{Type of value for mapping to the font size of keywords in the word clouds. There are two options:
"count": simply number of keywords; "pvalue": enrichment on keywords is performed (by fisher's exact test) and -log10(pvalue) is used to map to font sizes.}

\item{min_stat}{Minimal value for \code{stat} for selecting keywords.}

\item{exclude_words}{Words that are excluded in the word cloud.}

\item{max_words}{Maximal number of words visualized in the word cloud.}

\item{word_cloud_grob_param}{A list of graphic parameters passed to \code{word_cloud_grob}.}

\item{fontsize_range}{The range of the font size. The value should be a numeric vector with length two.
The font size interpolation is linear.}

\item{bg_gp}{Graphics parameters for controlling word cloud annotation background.}
}
\description{
A simplified way to visualize enrichment in GO clusters
}
\details{
There are several other ways to specify GO IDs and the associated values.
\enumerate{
\item specify \code{value} as a named vector where GO IDs are the names.
\item specify \code{value} as a list of numeric named vectors. In this case, \code{value} contains multiple enrichment results.
}

Please refer to \url{https://jokergoo.github.io/2023/10/02/simplified-simplifyenrichment-plot/} for more examples of this function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stats.R
\name{difference_score}
\alias{difference_score}
\title{Difference score}
\usage{
difference_score(mat, cl)
}
\arguments{
\item{mat}{The similarity matrix.}

\item{cl}{Cluster labels.}
}
\value{
A numeric scalar.
}
\description{
Difference score
}
\details{
This function measures the different between the similarity values for the terms
that belong to the same clusters and in different clusters. The difference score
is the Kolmogorov-Smirnov statistic between the two distributions.
}
\examples{
mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", 
    package = "simplifyEnrichment"))
cl = binary_cut(mat)
difference_score(mat, cl)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binary_cut.R
\name{plot_binary_cut}
\alias{plot_binary_cut}
\alias{binary_cut}
\title{Cluster functional terms by recursively binary cutting the similarity matrix}
\usage{
plot_binary_cut(
  mat,
  value_fun = area_above_ecdf,
  cutoff = 0.85,
  partition_fun = partition_by_pam,
  dend = NULL,
  dend_width = unit(3, "cm"),
  depth = NULL,
  show_heatmap_legend = TRUE,
  ...
)

binary_cut(
  mat,
  value_fun = area_above_ecdf,
  partition_fun = partition_by_hclust,
  cutoff = 0.85,
  try_all_partition_fun = TRUE,
  partial = nrow(mat) > 1500
)
}
\arguments{
\item{mat}{A similarity matrix.}

\item{value_fun}{A function that calculates the scores for the four submatrices on a node.}

\item{cutoff}{The cutoff for splitting the dendrogram.}

\item{partition_fun}{A function to split each node into two groups. Pre-defined functions
in this package are \code{\link[=partition_by_kmeanspp]{partition_by_kmeanspp()}}, \code{\link[=partition_by_pam]{partition_by_pam()}}  and \code{\link[=partition_by_hclust]{partition_by_hclust()}}.}

\item{dend}{A dendrogram object, used internally.}

\item{dend_width}{Width of the dendrogram on the plot.}

\item{depth}{Depth of the recursive binary cut process.}

\item{show_heatmap_legend}{Whether to show the heatmap legend.}

\item{...}{Other arguments.}

\item{try_all_partition_fun}{Different \code{partition_fun} may give different clusterings. If the vaule
of \code{try_all_partition_fun} is set to \code{TRUE}, the similarity matrix is clustered by three
partitioning method: \code{partition_by_pam()}, \code{partition_by_kmeanspp()} and \code{partition_by_hclust()}.
The clustering with the highest difference score is finally selected as the final clustering.}

\item{partial}{Whether to generate the complete clustering or the clustering stops when sub-matrices
cannot be split anymore.}
}
\value{
\code{binary_cut()} returns a vector of numeric cluster labels.
}
\description{
Cluster functional terms by recursively binary cutting the similarity matrix
}
\details{
After the functions which perform clustering are executed, such as \code{simplifyGO()} or
\code{binary_cut()}, the dendrogram is temporarily saved and \code{plot_binary_cut()} directly
uses this dendrogram.
}
\examples{
\donttest{
mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", 
    package = "simplifyEnrichment"))
plot_binary_cut(mat, depth = 1)
plot_binary_cut(mat, depth = 2)
plot_binary_cut(mat)
}
mat = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds",
    package = "simplifyEnrichment"))
binary_cut(mat)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.R
\name{cluster_terms}
\alias{cluster_terms}
\alias{cluster_by_kmeans}
\alias{cluster_by_pam}
\alias{cluster_by_dynamicTreeCut}
\alias{cluster_by_fast_greedy}
\alias{cluster_by_leading_eigen}
\alias{cluster_by_louvain}
\alias{cluster_by_walktrap}
\alias{cluster_by_mclust}
\alias{cluster_by_apcluster}
\alias{cluster_by_hdbscan}
\alias{cluster_by_MCL}
\title{Cluster terms based on their similarity matrix}
\usage{
cluster_terms(
  mat,
  method = "binary_cut",
  control = list(),
  verbose = se_opt$verbose
)

cluster_by_kmeans(mat, max_k = max(2, min(round(nrow(mat)/5), 100)), ...)

cluster_by_pam(mat, max_k = max(2, min(round(nrow(mat)/10), 100)), ...)

cluster_by_dynamicTreeCut(mat, minClusterSize = 5, ...)

cluster_by_fast_greedy(mat, ...)

cluster_by_leading_eigen(mat, ...)

cluster_by_louvain(mat, ...)

cluster_by_walktrap(mat, ...)

cluster_by_mclust(mat, G = seq_len(max(2, min(round(nrow(mat)/5), 100))), ...)

cluster_by_apcluster(mat, s = apcluster::negDistMat(r = 2), ...)

cluster_by_hdbscan(mat, minPts = 5, ...)

cluster_by_MCL(mat, addLoops = TRUE, ...)
}
\arguments{
\item{mat}{A similarity matrix.}

\item{method}{The clustering methods. Value should be in \code{\link[=all_clustering_methods]{all_clustering_methods()}}.}

\item{control}{A list of parameters passed to the corresponding clustering function.}

\item{verbose}{Whether to print messages.}

\item{max_k}{Maximal \emph{k} for k-means/PAM clustering. K-means/PAM clustering is applied from k = 2 to k = max_k.}

\item{...}{Other arguments.}

\item{minClusterSize}{Minimal number of objects in a cluster. Pass to \code{\link[dynamicTreeCut:cutreeDynamic]{dynamicTreeCut::cutreeDynamic()}}.}

\item{G}{Passed to the \code{G} argument in \code{\link[mclust:Mclust]{mclust::Mclust()}} which is the number of clusters.}

\item{s}{Passed to the \code{s} argument in \code{\link[apcluster:apcluster-methods]{apcluster::apcluster()}}.}

\item{minPts}{Passed to the \code{minPts} argument in \code{\link[dbscan:hdbscan]{dbscan::hdbscan()}}.}

\item{addLoops}{Passed to the \code{addLoops} argument in \code{\link[MCL:mcl]{MCL::mcl()}}.}
}
\value{
A vector of numeric cluster labels.
}
\description{
Cluster terms based on their similarity matrix
}
\details{
New clustering methods can be registered by \code{\link[=register_clustering_methods]{register_clustering_methods()}}.

Please note it is better to directly use \code{cluster_terms()} for clustering while not the individual \verb{cluster_by_*} functions
because \code{cluster_terms()} does additional cluster label adjustment.

By default, there are the following clustering methods and corresponding clustering functions:
\itemize{
\item \code{kmeans} see \code{\link[=cluster_by_kmeans]{cluster_by_kmeans()}}.
\item \code{dynamicTreeCut} see \code{\link[=cluster_by_dynamicTreeCut]{cluster_by_dynamicTreeCut()}}.
\item \code{mclust} see \code{\link[=cluster_by_mclust]{cluster_by_mclust()}}.
\item \code{apcluster} see \code{\link[=cluster_by_apcluster]{cluster_by_apcluster()}}.
\item \code{hdbscan} see \code{\link[=cluster_by_hdbscan]{cluster_by_hdbscan()}}.
\item \code{fast_greedy} see \code{\link[=cluster_by_fast_greedy]{cluster_by_fast_greedy()}}.
\item \code{louvain} see \code{\link[=cluster_by_louvain]{cluster_by_louvain()}}.
\item \code{walktrap} see \code{\link[=cluster_by_walktrap]{cluster_by_walktrap()}}.
\item \code{MCL} see \code{\link[=cluster_by_MCL]{cluster_by_MCL()}}.
\item \code{binary_cut} see \code{\link[=binary_cut]{binary_cut()}}.
}

The additional argument in individual clustering functions can be set with the \code{control} argument
in \code{cluster_terms()}.

\code{cluster_by_kmeans()}: The best k for k-means clustering is determined according to the "elbow" or "knee" method on
the distribution of within-cluster sum of squares (WSS) on each k. All other arguments are passed
from \code{...} to \code{\link[stats:kmeans]{stats::kmeans()}}.

\code{cluster_by_pam()}: PAM is applied by \code{\link[fpc:pamk]{fpc::pamk()}} which can automatically select the best k.
All other arguments are passed from \code{...} to \code{\link[fpc:pamk]{fpc::pamk()}}.

\code{cluster_by_dynamicTreeCut()}: All other arguments are passed from \code{...} to \code{\link[dynamicTreeCut:cutreeDynamic]{dynamicTreeCut::cutreeDynamic()}}.

\code{cluster_by_fast_greedy()}: All other arguments are passed from \code{...} to \code{\link[igraph:cluster_fast_greedy]{igraph::cluster_fast_greedy()}}.

\code{cluster_by_leading_eigen()}: All other arguments are passed from \code{...} to \code{\link[igraph:cluster_leading_eigen]{igraph::cluster_leading_eigen()}}.

\code{cluster_by_louvain()}: All other arguments are passed from \code{...} to \code{\link[igraph:cluster_louvain]{igraph::cluster_louvain()}}.

\code{cluster_by_walktrap()}: All other arguments are passed from \code{...} to \code{\link[igraph:cluster_walktrap]{igraph::cluster_walktrap()}}.

\code{cluster_by_mclust()}: All other arguments are passed from \code{...} to \code{\link[mclust:Mclust]{mclust::Mclust()}}.

\code{cluster_by_apcluster()}: All other arguments are passed from \code{...} to \code{\link[apcluster:apcluster-methods]{apcluster::apcluster()}}.

\code{cluster_by_hdbscan()}: All other arguments are passed from \code{...} to \code{\link[dbscan:hdbscan]{dbscan::hdbscan()}}.

\code{cluster_by_MCL()}: All other arguments are passed from \code{...} to \code{\link[MCL:mcl]{MCL::mcl()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/global.R
\name{se_opt}
\alias{se_opt}
\title{Global parameters}
\usage{
se_opt(..., RESET = FALSE, READ.ONLY = NULL, LOCAL = FALSE, ADD = FALSE)
}
\arguments{
\item{...}{Arguments for the parameters, see "details" section.}

\item{RESET}{Whether to reset to default values.}

\item{READ.ONLY}{Please ignore.}

\item{LOCAL}{Please ignore.}

\item{ADD}{Please ignore.}
}
\value{
A \code{GlobalOptionsFun} object.
}
\description{
Global parameters
}
\details{
There are the following global options:
\itemize{
\item \code{verobse}: Whether to print messages.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/word_cloud.R
\name{count_words}
\alias{count_words}
\title{Calculate word frequency}
\usage{
count_words(
  term,
  exclude_words = NULL,
  stop_words = stopwords(),
  min_word_length = 1,
  tokenizer = "words",
  transform_case = tolower,
  remove_numbers = TRUE,
  remove_punctuation = TRUE,
  custom_transformer = NULL,
  stemming = FALSE,
  dictionary = NULL
)
}
\arguments{
\item{term}{A vector of description texts.}

\item{exclude_words}{The words that should be excluded.}

\item{stop_words}{The stop words that should be be removed.}

\item{min_word_length}{Minimum length of the word to be counted.}

\item{tokenizer}{The tokenizer function, one of the values accepted by \code{tm::termFreq}.}

\item{transform_case}{The function normalizing lettercase of the words.}

\item{remove_numbers}{Whether to remove numbers.}

\item{remove_punctuation}{Whether to remove punctuation.}

\item{custom_transformer}{Custom function that transforms words.}

\item{stemming}{Whether to only keep the roots of inflected words.}

\item{dictionary}{A vector of words to be counted (if given all other words will be excluded).}
}
\value{
A data frame with words and frequencies.
}
\description{
Calculate word frequency
}
\details{
The text preprocessing followings the instruction from \url{http://www.sthda.com/english/wiki/word-cloud-generator-in-r-one-killer-function-to-do-everything-you-need}.
}
\examples{
gm = readRDS(system.file("extdata", "random_GO_BP_sim_mat.rds", package = "simplifyEnrichment"))
go_id = rownames(gm)
go_term = AnnotationDbi::select(GO.db::GO.db, keys = go_id, columns = "TERM")$TERM
count_words(go_term) |> head()
}
